/*
 * IClosedLine.java
 *
 * Created on 17 mars 2005, 08:18
 */

package jastex.obj;

/**
 *
 * @author steph
 */
public interface IClosedLine extends ILine {

    /**
     * Boolean flag defining whether nodes/others object are framed or not.
     * @return pNframe
     */
    public boolean getPNframe();

    /**
     * Setter for property PNframe.
     * @param PNframe New value of property PNframe.
     */
    public void setPNframe(boolean PNframe);

    /** Automatically set to true by the parameters */
    public boolean getPNfill();
    
   /** gray level used to fill nodes. 0=black, 1=white. */
    public float getPfillgray();

    /** color used to fill nodes
     * @see remarks on plineoclor in JasObject.java
     */
    public String getPfillcolor();

    /**
     * Setter for property PNfill.
     * @param PNfill New value of property PNfill.
     */
    public void setPNfill(boolean PNfill);

    /**
     * Setter for property pfillcolor.
     * @param pfillcolor New value of property pfillcolor.
     */
    public void setPfillcolor(String pfillcolor);

    /**
     * Setter for property pfillgray.
     * @param pfillgray New value of property pfillgray.
     */
    public void setPfillgray(float pfillgray);

}
