/*
 * JasVector.java
 *
 * Created on 17 mars 2005, 23:21
 */

package jastex.obj;
import java.util.*;
import java.awt.*;
import jastex.*;
import jastex.obj.graph.StdEdge;

/**
 *
 * @author steph
 */
public class JasVector extends Vector<IJasObject> implements IJasObject {
    
    protected GastexGlobalProperties globalProp;

    /** Creates a new instance of JasVector */
    public JasVector(GastexGlobalProperties _ggp) {
        setGgp(_ggp);
    }
    
    public String getLatexCode(double oriX, double oriY) {
        return "% TODO [JasVector]\n";
    }
    
    /* There is nothing interesting below... */

    public void setFromGgp(GastexGlobalProperties _ggp) {
        for (Enumeration<IJasObject> e = elements() ; e.hasMoreElements() ;) {
            e.nextElement().setFromGgp(_ggp);
        }
    }

    public void draw(Graphics2D g) {
        for (Enumeration<IJasObject> e = elements() ; e.hasMoreElements() ;) {
            e.nextElement().draw(g);
        }
     }

    /* There is nothing interesting below... */
    
    public GastexGlobalProperties getGgp() {
	return globalProp;
    }

    public void setGgp(GastexGlobalProperties _ggp) {
        globalProp = _ggp;
        setFromGgp(_ggp);
    }
}
