package jastex.old.gui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import jastex.*;
import jastex.gui.JasComboBox;



public class JasColorComboBox extends JasComboBox implements ActionListener {

    public ImageIcon colorIcon;
    public JButton colorBtn;
    
    public JasColorComboBox(String[] imageName, String[] imageCaption)
    {
	super(imageName,imageCaption);

	boolean isAppli = MainWindow.isAppli;	

	if (isAppli)
	    {
		 colorIcon = new ImageIcon("images/customcolor.gif");
	    }
	else 
	    {
		URL location;
		location = JasColorComboBox.class.getResource("images/customcolor.gif");
		colorIcon = new ImageIcon(location);
	    }


	colorBtn = new JButton(colorIcon);
	colorBtn.setActionCommand("customcolor");
	colorBtn.addActionListener(this);
	colorBtn.setToolTipText(Languages.ccb_customcolor);
	colorBtn.setPreferredSize(new Dimension(20,20));
	add(colorBtn);
	
    }
    

 public void actionPerformed(ActionEvent e)
     {
	 if(e.getActionCommand().equals("customcolor"))
	     {
		 JasColorChooser cc = new JasColorChooser(this);
	     }
     }


 public String getSelected()    { return ((ImageIcon)comboList.getSelectedItem()).getDescription();    }

    public void setEnabled(boolean bool)
    {
	super.setEnabled(bool);
	colorBtn.setEnabled(bool);
    }
    
}
