package jastex.old.gui;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import java.net.URL;

import javax.swing.*;
import javax.swing.border.*;

public class SplashScreen extends JWindow
{
    
    
    public  SplashScreen(String imageFile, int time)
    {
	setBackground(Color.lightGray);
	
	// On récupère l'image
	ImageIcon image = new ImageIcon(imageFile);
	
	//Création du panel et mise en forme.
	JPanel pane = new JPanel(new BorderLayout());
	pane.setFont(new Font("Monospaced", 0, 14));
	
	// Ajout des composants dans le panel
	pane.add(BorderLayout.NORTH,new JLabel(image));
	pane.add(BorderLayout.SOUTH, new JLabel("Released under Gnu GPL - Release du 28 Juin 2002",SwingConstants.CENTER));
	pane.setBorder(new EtchedBorder(EtchedBorder.RAISED));
	getContentPane().add(pane);
	pack();
	centerComponent(this);
	setVisible(true);
	
	
	MouseAdapter ma = new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		    dispose();
		}
	    };

	addMouseListener(ma);

	if (time != 0) {
	    Action closeSplashScreen = new AbstractAction() {
		    public void actionPerformed(ActionEvent e) {
			dispose();
		    }
		};
	    
	    
	    new javax.swing.Timer(time, closeSplashScreen).start();
	}
	
    } 

    public static void createMainWindow(String img, int time) {
	SplashScreen mw = new SplashScreen(img, time);
	mw.pack();
	centerComponent(mw);
	mw.setVisible(true);
	mw.toFront();
    }
	
    
    public static Dimension getScreenDimension()
    {
	return Toolkit.getDefaultToolkit().getScreenSize();
    }

    public static void centerComponent(Component compo)
    {
	compo.setLocation(new Point((getScreenDimension().width - compo.getSize().width) / 2,
				    (getScreenDimension().height - compo.getSize().height) / 2));
    }
}







