package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import java.util.*;

import jastex.*;
import jastex.old.gui.JasObjectToolBox;


/** This class implements some kind of invisible node used to draw
 * edges without Node
 * Almost all methods are disabled
 * @see ANode 
*/
public class InvisibleNode extends ANode {
    
    public InvisibleNode(GastexGlobalProperties ggp) {
	super();
	nodeName = "NoName";
	nodeNum--;
	globalProp = ggp;
    }

    public InvisibleNode(GastexGlobalProperties ggp, double px, double py) {
	// this constructeur is for Parser
	this(ggp);
	// in unitlength
	setPos((int) ggp.unitLength2Internal(px),
	       (int) ggp.unitLength2Internal(py));
    }
    //void draw(Graphics g) {}
 
    public Rectangle getBounds() {return (new Rectangle(5,5)); }
    
 
    public boolean isInsideRectangle(Rectangle r) { return false; }
    
 
    public double getMinDistance(int gx,int gy) {
	return (getBounds().contains(gx,gy)?0:1000);
    }

    
 
    public boolean contains(double gx, double gy) { return false; }
    
 
    public boolean contains (Point2D pt) {return false; }
    
    /* 
    void setPos(int posx, int posy) {
	x = posx;
	y = posy;
    }
    */
    
 
    public void addImark() {}			
    public void addImark(IFMark ifm) {}			
    
 
    public void delIMark(IFMark mark) {}
    
 
    public void addRmark() {}			
    public void addRmark(RMark rm) {}

 
    public void delRMark(RMark mark) {}

 
    public void addFmark() {}			

    public void addFmark(IFMark ifm) {}			
    
    public void addIFmark(IFMark ifm) {}

 
    public void delFMark(IFMark mark) {}

 
    public double deprecated_getULY() {
	return (-globalProp.internal2UnitLength(deprecated_y));
    }
    public double deprecated_getULX() {
	return (globalProp.internal2UnitLength(deprecated_x));
    } 
    
    public void addLabel(String l) {}
     public void addLabel(String l, boolean pExt, 
			 double pAngle, double pDist) {}
 
    public void addLabel(NodeLabel jl) {}

 
    public void delLabel(NodeLabel jl) {}

    public void updateVector(Vector v){}

 
    public double getActualHeight(){ return 0; }
    public double getActualHeight(Graphics g){ return 0; }

 
    public double getActualWidth(){ return 0;}
    public double getActualWidth(Graphics g){ return 0; }

    public double getHeight(){ return 0;}
    public double getWidth(){ return 0;}
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager) {}

    public void draw(Graphics g) {
	g.setColor(Color.red);
	g.drawLine(deprecated_x,deprecated_y,deprecated_x+10,deprecated_y+10);
    }

    public Selection getObjectSelection(Rectangle slct){return null;}
}
