package jastex.old.obj;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



/* Extension of the file Selection.java
   easier to read
*/
public class SelectCircle extends Selection {

    public MiniBox b1;

    public MiniBox b2;

    public MiniBox b3;
    public Circle rCurve;

    public SelectCircle(){}

    public SelectCircle(Circle rc){
	rCurve=rc;
	miniB=new Vector();
	b1=new MiniBox(rc.deprecated_getX(),rc.deprecated_getY());
	b2=new MiniBox((int)(rc.deprecated_getX()+rc.getDiameterInternal()/2),rc.deprecated_getY());
	//b3=new MiniBox(rc.getX(),(int) (rc.getY()-rc.getDiameterInternal()/2));
	miniB.addElement(b1);
	miniB.addElement(b2);
	//miniB.addElement(b3);
	b1.setSensitive(false); // box 1 is not movable
	b2.setSensitive(true);
	//b3.setSensitive(true);
	b2.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b2.setDepends(this);
	//b3.cursor=new Cursor(Cursor.MOVE_CURSOR);
	//b3.setDepends(this);
    }

    public double getMinDistance(int gx,int gy){ return 1000.0; }

    public void setOffset(int posx,int posy) {}
    public void setPos(int posx,int posy) {}
    public void draw(Graphics g){
	Graphics2D g2=(Graphics2D) g ;
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);

	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();

	Line2D.Double one2two=new Line2D.Double(e1,e2);

	g2.draw(one2two);
	g2.setStroke(new BasicStroke()); 
    }

    public Rectangle getBounds(){
	Rectangle r=new Rectangle(rCurve.getBounds());
	r.add(b1.pos2Point2D());
	r.add(b2.pos2Point2D());
	//r.add(b3.pos2Point2D());
	r.grow(5,5);
	return r;
    }

    public void updatingSelection(){
	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();
	
	rCurve.setDiameterInternal(e1.distance(e2)*2);
    } 

    public void updatingSelection(MiniBox mb){ updatingSelection(); }
    public void recadre(){}
    public Point returnDeplacement() {return null;}   
}
