package jastex.old.obj;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import java.awt.font.*;

import jastex.*;

import jastex.old.gui.JasObjectToolBox;



/* Extension of the file Selection.java
   easier to read
*/
public class SelectEdgeLabel extends Selection implements IJasTextEdit {

    public Point p1;

    public Point p2;
    public MiniBox b1;

    public MiniBox b2;
    public EdgeLabel jlb;
    public Rectangle r;
    public int offsetx=0;

    public int offsety;
    public double tpos;
    public double tXpos;
    public double pas;

    public SelectEdgeLabel(){}

    public SelectEdgeLabel(EdgeLabel jlbe){
	jlb=jlbe;
	miniB=new Vector();
	Point2D pt=jlb.getEdge().getcurvePosLabel2();
	double pt1x=jlb.getEdge().startingpoint.deprecated_getX();
	double pt2x=jlb.getEdge().endingpoint.deprecated_getX();

	if((pt1x-pt2x)==0) pas=10;
	else pas=100/Math.abs(pt1x-pt2x);
	//if(pas<10) pas=10;
	//System.out.println(pas);

	tpos=jlb.getpELpos();

	b1=new MiniBox((int)pt.getX(),(int)pt.getY());
	miniB.addElement(b1);
	b1.setSensitive(true);
	b1.cursor=new Cursor(Cursor.E_RESIZE_CURSOR);
	b1.setDepends(this);
	b1.setInvisibleMode(true);
	tXpos=pt.getX();

	pt=jlb.getEdge().getcurvePosLabel();
	b2=new MiniBox((int)pt.getX(),(int)pt.getY());
	miniB.addElement(b2);
	b2.setSensitive(true);
	b2.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b2.setDepends(this);
	//b2.setColor(Color.orange);
	b2.setInvisibleMode(true);

	cursor=new Cursor(Cursor.TEXT_CURSOR);
       	r=jlb.getBounds();
	
	setPos((int) r.getCenterX(),(int) r.getCenterY());
    }

    public double getMinDistance(int gx,int gy){
	if (getBounds().contains(gx,gy)) return 0;
	return 1000.0;
    }

    public void setOffset(int posx,int posy) {
	offsetx=0; //posx-x;
	offsety=0; //posy-y;
    }

    public void setPos(int posx,int posy) {
	deprecated_x=posx-offsetx; 
	deprecated_y=posy-offsety;

	//Point2D pt=jlb.getNode().pos2Point2D();
	//Point2D actualpt=pos2Point2D();
	//jlb.updateAngle(actualpt);
	//jlb.setpNLdist(pt.distance(actualpt)/(jlb.getGgp().ratio*Configuration.scale));
    }

    public void draw(Graphics g)
    { 
       	Graphics2D g2=(Graphics2D) g ;
	r=new Rectangle(jlb.getBounds());
	r.grow(5,5);
	g2.setColor(Color.gray);
        g2.draw(r);

	// miniBox
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);
	Point2D e1=b1.pos2Point2DFake();
	Point2D e2=b2.pos2Point2DFake();
	Line2D.Double one2two=new Line2D.Double(e1,e2);
	g2.draw(one2two);
	g2.setStroke(new BasicStroke()); 
    }

    public Rectangle getBounds(){
	return r;
    }

    public void updatingSelection(){
	/*
	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();
	double diff=tpos+(e1.getX()-tXpos)*pas;
	if(diff<0) diff=0;
	if(diff>100) diff=100;
	jlb.setpELpos(diff);


	Point2D pt=jlb.getEdge().getcurvePosLabel2();
	b1.setFakePos((int)pt.getX(),(int)pt.getY());
	pt=jlb.getEdge().getcurvePosLabel();
	b2.setFakePos((int)pt.getX(),(int)pt.getY());*/
    } 
    public void updatingSelection(MiniBox mb){
	//updatingSelection();
	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();
	if (mb==b1){
	    int sens=(jlb.getEdge().endingpoint.pos2Point2D().getX()>
			 jlb.getEdge().startingpoint.pos2Point2D().getX())?1:-1;
	    double diff=tpos+(e1.getX()-tXpos)*pas*sens;
	    if(diff<0) diff=0;
	    if(diff>100) diff=100;
	    jlb.setpELpos(diff);
	    

	    Point2D pt=jlb.getEdge().getcurvePosLabel2();
	    b1.setFakePos((int)pt.getX(),(int)pt.getY());
	    pt=jlb.getEdge().getcurvePosLabel();
	    b2.setFakePos((int)pt.getX(),(int)pt.getY());
	} else if(mb==b2){
	    //	    double diff=e1.distance(e2);

	    //jlb.setpELdistInternal(diff);
	    jlb.setLabelPos(e2);
	    Point2D pt=jlb.getEdge().getcurvePosLabel();
	    b2.setFakePos((int)pt.getX(),(int)pt.getY());
	    //setpELside(double pELs)
	}
    }

    public void recadre(){}
    public Point returnDeplacement() {return null;}   
    public void setCarretIndex(int insertionIndex){
	jlb.insertionIndex=insertionIndex;
    }

    public boolean isEditable(){ return jlb.editable(); }
    public Point2D getLayoutOrigin(){ return jlb.layoutOrigin; }
    public TextLayout getActualLayout(){ return jlb.getActualLayout(); }
    public INELabel getNEL() { return jlb; }

    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){
	tooBox.updateDistance(jlb.getpELdist());
	tooBox.updatePosition(jlb.getpELpos());
	tooBox.updateSide(jlb.getpELside());
	//updateDistance(double dist) et updatePosition(double pos)
    }
}




