package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;




public class SelectExtendedQuad extends SelectBezierQuadCurve{

    public SelectExtendedQuad(ExtendedQuad ec){
	super(ec);
	b1.setSensitive(true);
	b1.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b1.setDepends(this);
	b2.setSensitive(true);
	b2.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b2.setDepends(this);
	b1.setColor(Color.red);
	b2.setColor(Color.red);

    }

    public void updatingSelection(){
	Point2D sn,en;
	sn=b1.pos2Point2D();
	en=b2.pos2Point2D();
	rCurve.startingpoint.setPos((int) sn.getX(),
				    (int) sn.getY());
	rCurve.endingpoint.setPos((int) en.getX(),
				  (int) en.getY());	
	rCurve.setCtrlPt(b3.pos2Point2D());
	rCurve.adjustCurve();

	
	b1.setFakePos(rCurve.startingpoint.deprecated_getX(),
		      rCurve.startingpoint.deprecated_getY());
	b2.setFakePos(rCurve.endingpoint.deprecated_getX(),
		      rCurve.endingpoint.deprecated_getY());
	b3.setFakePos((int)rCurve.getCtrlPt().getX(),
		      (int)rCurve.getCtrlPt().getY());
    } 

    public MiniBox getRelativeMB(MiniBox mb){
	if(mb==b1) return b2;
	else if(mb==b2) return b1;
	else return b3;
    }

}
