/*
 * SelectIMark.java
 *
 * Created on 6 mars 2005, 10:40
 */

package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



public class SelectIMark extends Selection {

    public Point p1;

    public Point p2;

    public MiniBox b1;

    public MiniBox b2;
    public IFMark ifm;

    public SelectIMark(){}

    public SelectIMark(IFMark ifm){
	miniB=new Vector();
	b1=new MiniBox(ifm.getNode().deprecated_getX(),ifm.getNode().deprecated_getY());
	b2=new MiniBox((int) ifm.getLine().getX2(),(int) ifm.getLine().getY2());
	miniB.addElement(b1);
	miniB.addElement(b2);
	b1.setSensitive(false); // box 1 is not movable
	b1.setColor(Color.orange);
	b2.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b2.setDepends(this);
	this.ifm=ifm;
    }

    public double getMinDistance(int gx,int gy){
	// not selectable
	return 1000.0;
    }

    public void recadre(){}
    public void setOffset(int posx,int posy) {}
    public Point returnDeplacement() {return null;}
    public void setPos(int posx,int posy) {}

    public void draw(Graphics g){}

    public Rectangle getBounds(){
	// the Bounds of this selection is:
	// the ifmark bound + the center of the node.
	Point2D pt=ifm.getNode().pos2Point2D(); // get the Node
	Rectangle rtemp=ifm.getBounds();
	rtemp.add(pt);
	return (rtemp);
    }

    public void updatingSelection(){
	Point2D pt=b2.pos2Point2D();

	// hack

	//double oldangle= ifm.getpangle();
	if ((pt.getX()==(double) ifm.getNode().deprecated_getX())
	    && (pt.getY()==(double) ifm.getNode().deprecated_getY()))
	    //pt=new Point2D.Double(pt.getX()+0.1,pt.getY());
	    return;
	// ***

	Point2D intersection=ifm.getIntersection(pt); // get the new intersection
	ifm.updateAngle(pt);
	
	double di=intersection.distance(pt)/(ifm.getGgp().ratio*Configuration.scale); // to corect
	
	if(ifm.getNode().contains(pt)) di=-di; 
	ifm.setplength(di);

	b2.setFakePos((int) ifm.getLine().getX2(),
		      (int) ifm.getLine().getY2());
	return;
    } 

    public void updatingSelection(MiniBox mb){
	updatingSelection();
    }


    
}

