package jastex.old.obj;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



public class SelectOval extends Selection {

    public MiniBox b1;

    public MiniBox b2;

    public MiniBox b3;
    public Oval rCurve;

    public SelectOval(){}

    public SelectOval(Oval rc){
	rCurve=rc;
	miniB=new Vector();
	int ulcx=(int)(rc.deprecated_getX()+rc.getInternalWidth()/2);
	int ulcy=(int)(rc.deprecated_getY()-rc.getInternalHeight()/2);

	b1=new MiniBox(rc.deprecated_getX(),rc.deprecated_getY());
	b2=new MiniBox(ulcx,rc.deprecated_getY());
	b3=new MiniBox(rc.deprecated_getX(),ulcy);
	miniB.addElement(b1);
	miniB.addElement(b2);
	miniB.addElement(b3);
	b1.setSensitive(false);
	b1.setColor(Color.orange);
	b2.setSensitive(true);
	b2.setInvisibleMode(true);
	b3.setSensitive(true);
	b3.setInvisibleMode(true);
	b2.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b2.setDepends(this);
	b3.cursor=new Cursor(Cursor.MOVE_CURSOR);
	b3.setDepends(this);
    }

    public double getMinDistance(int gx,int gy){ return 1000.0; }

    public void setOffset(int posx,int posy) {}
    public void setPos(int posx,int posy) {}
    public void draw(Graphics g){
	Graphics2D g2=(Graphics2D) g ;
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);

	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2DFake();
	Point2D e3=b3.pos2Point2DFake();

	Line2D.Double one2two=new Line2D.Double(e1,e2);
	Line2D.Double one2three=new Line2D.Double(e1,e3);

	g2.draw(one2two);
	g2.draw(one2three);
	g2.setStroke(new BasicStroke()); 
    }

    public Rectangle getBounds(){
	Rectangle r=new Rectangle(rCurve.getBounds());
	r.add(b1.pos2Point2D());
	r.add(b2.pos2Point2D());
	r.add(b3.pos2Point2D());
	r.grow(5,5);
	return r;
    }

    public void updatingSelection(){
	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();
	Point2D e3=b3.pos2Point2D();
	
	double w2,h2,r,sign1,sign2;
	r=rCurve.getRatioMr(); // save old Mr
	w2=e1.getX()-e2.getX();
	h2=e1.getY()-e3.getY();
	
	sign1=(w2<0)?1:-1;
	sign2=(h2<0)?-1:1;

	if(Math.abs(w2)<=1) w2=3;
	if(Math.abs(h2)<=1) h2=3;

	rCurve.setInternalWidth(Math.abs(w2*2));
	rCurve.setInternalHeight(Math.abs(h2*2));
	rCurve.setRatioMr(r);

	b2.setFakePos((int)(rCurve.deprecated_getX()+rCurve.getInternalWidth()/2*sign1),
		      rCurve.deprecated_getY());
	b3.setFakePos(rCurve.deprecated_getX(),
		      (int)(rCurve.deprecated_getY()-rCurve.getInternalHeight()/2*sign2));

    } 

    public void updatingSelection(MiniBox mb){ updatingSelection(); }
    public void recadre(){}
    public Point returnDeplacement() {return null;}   
}
