package jastex.parsing;
import java.util.Vector;
import java.io.*;
import javax.swing.*;
import jastex.*;

public class JasParserBlock extends JasParser2 {

    public JasParserBlock(String code,  // the part of code to parse
		   GastexGlobalProperties ggp, // the actual global property
		   double offx, double offy,
		   double w,double h,
		   Vector vectorOfNode,
		   Vector nodeNameVector,
		   boolean pictureStarted){
	super(code);
	this.ggp=new GastexGlobalProperties(ggp);  // duplicate ... simulate a stack
	this.offx=offx;
	this.offy=offy;
	this.w=w;
	this.h=h;
	this.pictureStarted=pictureStarted;
	//this.vectorOfNode=(Vector) vectorOfNode.clone(); // clone in order to link "upper" nodes
	//this.nodeNameVector=(Vector) nodeNameVector.clone();

	this.vectorOfNode=vectorOfNode;
	this.nodeNameVector=nodeNameVector;
    }

    public boolean parse(){
	// droppingHeader(); <<-- no dropping header
	// if(isErrorDetected()){
	//    System.out.println(erreurString); return false;
	// }
	int nnn;
	while((nnn=getNextBlock())!=-1){
	    if(isErrorDetected()) {System.out.println(erreurString); return false;}
	    if(!parsingAction()) { 
		System.out.println(erreurString);
		return false;
	    }
	}
	// last verif
	if(isErrorDetected()){
	    System.out.println(erreurString); return false;
	}
	return true;
    }

}
