package jastex.parsing;
import java.util.Vector;
import jastex.*;

public class OptionVal{

    public int oi;
    public boolean ob;
    public double od;
    public boolean isEmpty=false;
    public String otxt;
    public float[] oflist;
    public float   of;
    public boolean err=false;

    public Vector v1;

    public Vector v2;

    public OptionVal(){isEmpty=true;}

    public OptionVal(int i){oi=i;}
    public OptionVal(boolean b){ob=b;}
    public OptionVal(double d){od=d;}
    public OptionVal(String txt){otxt=txt;}
    public OptionVal(float[] lof,float f){oflist=lof; of=f;}
    public OptionVal(Vector v1,Vector v2){this.v1=v1; this.v2=v2;}
    

    public boolean optEmpty() {return isEmpty; }

    public boolean initiateArray(){
	String temp;
	err=false;
	if(v1==null || v2==null) return true;

	int sz=v1.size();
	if(sz==0){oflist=null;}
	else {

	    oflist=new float[sz];
	    for(int i=0;i<sz;i++){
		temp=(String) v1.elementAt(i);
		oflist[i]=getNumber(temp);
	    }
	}
	temp=(String) v2.elementAt(0);
	of=getNumber(temp);
	return err;
    }
    
    public float getNumber(String value){
	float val;
	try {
	    val=Float.parseFloat(value);
	} catch (NumberFormatException e) {
	    System.out.println(value);
	    err=true;
	    return 0;
	}
	return val;
    }
}
