package jastex;
import java.awt.Color;
import jastex.old.gui.JasColorChooser;

/**
 * Cette classe associe un nom a une couleur definie
 */
public class JasColorName extends javax.swing.JComponent {
    private Color color;
    private String name;
    
    /**
     * Constructeur utilisé dans la ComboBoxColor
     */
    public JasColorName(Color c, String s) { color = c; name = s; }
    
    /**
     * Constructeur utilisé dans GenereTex
     * (a partir du nom de la couleur, retourne un ColorName)
     */
    public JasColorName(String s) {
	color = new Color(0,0,0);		// en cas de probleme.. de reconnaissance de couleur
	name = "noir";			        // c du noir...
	
	JasColorName x;
	for(int i=0; i<JasColorChooser.COLOR.length; i++) {
	    x = JasColorChooser.COLOR[i];
	    if(x.name.equals(s)) {
		name = s;
		color = x.color;
		break;
	    }
	} /* fin du for */    
    }
    
    public Color getColor() { return color; }
    public String getColorName() { return name; }
}
