package jastex;

public class JasDash {

    public float [] pdash_length = null;
    public float pdash_empty;
    
    public JasDash(float[] pdash_length, float pdash_empty)
    {
	if(pdash_length != null)  {
	    this.pdash_length = new float[pdash_length.length];
	    for(int i=0; i< pdash_length.length; i++)
		this.pdash_length[i] = pdash_length[i];
	}
	this.pdash_empty = pdash_empty;
    }
    
    public boolean equals(JasDash d) {
        int n = pdash_length.length;
        
        if (d == this) return true;
        
        if (pdash_empty != d.pdash_empty || n != d.pdash_length.length)
            return false;
        
        for (int i = 0; i < n; i++) {
            if (d.pdash_length[i] != pdash_length[i]) return false;
        }
        
        return true;
    }

    public float[] getDashLength() { return pdash_length; }
    public float getDashEmpty() { return pdash_empty; }
}
