package jastex.old.gui;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import jastex.*;
import jastex.old.gui.tabs.OJasTab;

class JasAboutBox extends JasToolBox implements ActionListener {


    /** tab icons */
    public static ImageIcon tabIcons[];
    public JTabbedPane tPane = new JTabbedPane();


    public JasAboutBox(Frame parentFrame , String toolBoxTitle)
    {
	
	super(parentFrame,toolBoxTitle);
	
	/* Apply Buton */
	JButton okButton = new JButton(Languages.tb_OkBtn);
	okButton.setActionCommand("ok");
	okButton.addActionListener(this);
	
	
	JPanel buttonPane = new JPanel(); 
	buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.X_AXIS));
	buttonPane.add(Box.createHorizontalGlue());
	buttonPane.add(okButton);
	
	GridBagLayout layout = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.BOTH;	
	getContentPane().setLayout(layout);
	
	c.gridx=0;
	c.gridy=0;
	layout.setConstraints(tabbedPane,c);
	getContentPane().add(tabbedPane);
	
	c.gridx=0;
	c.gridy=1;
	c.insets = new Insets(5,0,0,0);
	layout.setConstraints(buttonPane,c);
	getContentPane().add(buttonPane);


	OJasTab aboutTab = new OJasTab("JasTeX v1.1");
	//JTextArea aboutText = new JTextArea("JasTeX est une interface Java pour Gastex un jeu de macro pour latex\n"+
	//				    "Il a été développé dans le cadre d'un Travail d'Etude et de Recherche (TER) de "+
	//				    "Maîtrise informatique à l'université Denis Diderot Paris 7.\n\n"+
	//				    "Ce programme est distribué sous les termes de la license GNU GPL\n\n"+
	//				    "http://www.sourceforge.net/projects/jastex/",				    
	//				    10,30);
	JEditorPane aboutText = new JEditorPane("text/html","<body><h2> JasTeX version 1.1</h2>"+
						"<font face=\"arial\" size=\"2\"><p>Il a été développé dans le cadre<br>"+
						"d'un Travail d'Etude et de Recherche (TER)<br>"+
						"de Maîtrise informatique à <br><a href=\"www.ufr-info-p7.jussieu.fr\">"+
						"l'université Denis Diderot Paris 7</a>.</p>"+
						"<p>Ce programme est distribué sous<br>les termes de la license GNU GPL.</p>"+
						"<p>Vous pouvez trouver la dernière<br>version de JasTeX (CVS)"+
						" à l'adresse :<br> <a href=\"http://www.sourceforge.net/projects/jastex/\""+
						">http://www.sourceforge.net/projects/jastex/</a></p></font></body>");

	//aboutText.setLineWrap(true);
	//aboutText.setWrapStyleWord(true);
	aboutText.setEditable(false);
	aboutText.setSize(430,220);
	
	aboutTab.insertPropertie(aboutText);

	addTab(aboutTab);
	tabbedPane.addTab(aboutTab.getTabTitle(),aboutTab.getPanel());

	OJasTab authorsTab = new OJasTab("Auteurs");
	JEditorPane authorsText = new JEditorPane("text/html","<body><h2>Auteurs</h2><font face=\"arial\" size=\"2\">"+
						"Les auteurs de JasTeX sont: <br><br>"+
						"Michel DUONG <a href=\"mailto:teomahoro@sourceforge.net\">&lt;teomahoro@sourceforge.net&gt;<br></a>"+
						"Grégory KOKANOSKY <a href=\"mailto:ratm@sourceforge.net\">&lt;ratm@sourceforge.net;<br></a>"+
						"Yannick OZOUF <a href=\"mailto:vitamin@sourceforge.net\">"+
						"&lt;vitamin@sourceforge.net&gt;<br></a></font>");
	//JLabel authors = new JLabel("Auteurs:");
	//JLabel xeus = new JLabel ("Michel DUONG <mduong@wanadoo.fr>");
	//JLabel ratm = new JLabel ("Grégory KOKANOSKY <greg@epplug.org>");
	//JLabel inc = new JLabel("Yannick OZOUF <yannick.ozouf@wanadoo.fr>");
	//authorsTab.insertPropertie(authors);
	//authorsTab.insertPropertie(xeus);
	//authorsTab.insertPropertie(ratm);	
	//authorsTab.insertPropertie(inc);
	authorsText.setEditable(false);
	authorsText.setSize(430,220);
	authorsTab.insertPropertie(authorsText);
	addTab(authorsTab);
	tabbedPane.addTab(authorsTab.getTabTitle(),authorsTab.getPanel());
		
	
	OJasTab creditsTab = new OJasTab("Crédits");
	
	JEditorPane thanx = new JEditorPane("text/html","<body><h2>Crédits</h2><font face=\"arial\" size=\"2\">"+
					    "Remerciements : <br><br>"+
					    "à Paul Gastin"+
					    "<a href=\"mailto:Paul.Gastin@liafa.jussieu.fr\">"+
					    "&lt;Paul.Gastin@liafa.jussieu.fr&gt;</a><br>(concepteur de Gastex)</a><br>"+
					    "De nous avoir aidé et encadré lors du développement de JasTeX.<br><br>"+
					    "Aux auteurs du thèmes d'icones Conectiva Crystal <br>"+
					    "outrageusement utilisé dans JasTeX<br>"+
					    "<a href=\"(http://www.kde-look.org/content/show.php?content=1586\">"+
					    "(http://www.kde-look.org/content/show.php?content=1586)</font></body>");
	//thanx.setLineWrap(true);
	//thanx.setWrapStyleWord(true);
	thanx.setEditable(false);
	thanx.setSize(430,220);
	creditsTab.insertPropertie(thanx);

	addTab(creditsTab);
	tabbedPane.addTab(creditsTab.getTabTitle(),creditsTab.getPanel());
	

	pack();
	setVisible(true);
    }
    
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if (cmd.equals("ok"))
	    {
		dispose();
	    }
    }

}
