package jastex.old.gui;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;


/** This class create the toolbox in order to modify
 * Node or Edge properties
 */
class JasListTextDlg extends JDialog {
    
    public JList textList;
    public DefaultListModel listModel;
    public JButton okBtn;

    public JasListTextDlg(Frame parentFrame , String title,boolean modal)
    {
	super(parentFrame,title,modal);
	listModel = new  DefaultListModel();
	textList = new JList(listModel);
	JScrollPane scrollPane = new JScrollPane(textList);
	okBtn = new JButton("OK");

	GridBagLayout layout = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.BOTH;	
	getContentPane().setLayout(layout);
	
	c.gridx=0;
	c.gridy=0;
	layout.setConstraints(scrollPane,c);
	getContentPane().add(scrollPane);
	
	c.gridx=0;
	c.gridy=1;
	c.insets = new Insets(5,0,0,0);
	layout.setConstraints(okBtn,c);
	getContentPane().add(okBtn);
	
	pack();
	setVisible(true);
    }


    public void addText(String text) {	listModel.addElement(text);    }

    public void addActionListener(ActionListener listener)    {	okBtn.addActionListener(listener);    }

}
