package jastex.old.gui;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;

public class MessageBox extends JFrame{
    public int reply;
    public JDialog dialog;


  public MessageBox(String title, String text, int type) {
      super();
      dialog = new JDialog(this, title, true);
      reply = 0;
      
      switch (type) {
      case 0:
	  JOptionPane.showMessageDialog(dialog,
					text,
					title,
					JOptionPane.WARNING_MESSAGE);
	  reply = 1;
	  break;
	  
      case 1:
	  int n = JOptionPane.showConfirmDialog(dialog,
						text,
 						title,
 						JOptionPane.YES_NO_OPTION);
	  reply = n+1;
	  break;
      
      default:
	  return;
      }
      dialog.setModal(true);
      centerComponent(dialog);
  }
        
   
    
    public Dimension getScreenDimension()
    {
	return Toolkit.getDefaultToolkit().getScreenSize();
    }
    
    
    
    
    public void centerComponent(Component compo)
    {
	compo.setLocation(new Point((getScreenDimension().width - compo.getSize().width) / 2,
				    (getScreenDimension().height - compo.getSize().height) / 2));
    }
}
