package jastex.old.gui;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;


/** This class fix a JComboBox bug
http://developer.java.sun.com/developer/bugParade/bugs/4133743.html
Bug Id    4133743
Synopsis JComboBox.getSelectedIndex fails with duplicate entries
**/
public class MyJComboBox extends JComboBox {

    private int iSelectedIndex = 0;
    
    public void setSelectedIndex(int anIndex) {
        anIndex = anIndex < 0 ? 0 : anIndex;
        iSelectedIndex = anIndex;
        int size = super.dataModel.getSize();
	
        if ( anIndex >= size )
            throw new IllegalArgumentException
		("setSelectedIndex: " + anIndex + " out of bounds");
        super.setSelectedItem(super.dataModel.getElementAt
			      (anIndex));
    }
    
    public int getSelectedIndex() {
        return iSelectedIndex ;
    }
}
