package jastex.old.gui;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import javax.swing.SwingUtilities;
import java.awt.Cursor;
import java.awt.font.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.net.*;

import jastex.*;
import jastex.old.obj.IJasTextEdit;
import jastex.old.obj.SelectBox;
import jastex.old.obj.Selection;
import jastex.old.obj.AEdge;
import jastex.old.obj.MiniBox;
import jastex.old.obj.Node;
import jastex.old.obj.IFMark;
import jastex.old.obj.JasObject;
import jastex.old.obj.SimpleObject;
import jastex.old.obj.SimpleObjectN;
import jastex.old.obj.INELabel;
import jastex.old.obj.NodeLabel;
import jastex.old.obj.SimpleObjectE;
import jastex.old.obj.RMark;
import jastex.old.obj.ANode;

public class SurfaceDessin extends JPanel implements MouseMotionListener, MouseListener, KeyListener{

    public boolean sboxdel=false;
    public boolean _DEBUG=false;

    // internal parameter
    private double tailleGrille;
    private int surfX,surfY;        // actual mouse's position
    private boolean isDrag=false;   // if we are dragging sthg
    private boolean isSelecting=false;   // if we are dragging sthg
    public int indexObject = -1;           // index of the object at position surfX,surfY
    public ObjetManager manager;           // the object manager

    public int dragX;

    public int dragY;                // for dragging initial position
    //**** Select Zone ****
    public int supleX;  // for selecting

    public int supleY;

    public int coteX;

    public int coteY;
    public Cursor defaultC=new Cursor(Cursor.CROSSHAIR_CURSOR); //define some cursor
    public Cursor handC=new Cursor(Cursor.HAND_CURSOR);
    public boolean select=false; // for selecting
    public long timestamp;

    // Needed to optimize the application speed
    public Rectangle oldRedrawZone=null;
    public Rectangle newRedrawZone=null;

    //**** 
    private int defaultitem=0; 
    private int defaulttype=0;
    private boolean _ANTIALIASING=true;
    private static boolean _MAGNETIC=true;
    public boolean dontDeleteSelection=false;
    // A reference to the actual ToolBox
    // --> needed for updating objects
    public static JasObjectToolBox tooBox;
    public ObjectControlMenu ocmenu;
    public Graphics2D gRefLabel; //useful for label
    public JLabel statusBar;

    // Font
    private boolean firstime=true;
    private String[] msgStatus;
    // Text
    private boolean editingText=false;
    public TextLayout ttCode;
    public int insertionIndex;
    public INELabel nlabel; //NodeLabel nlabel;

    // ****
    public boolean isApplet=false;

    // Copy-Paste
//     JasObject copyPaste;
    public static Vector copyPaste;
    public Vector collection;
    public static Point selectCenter;

    //

    public boolean snapToGrid;
    public boolean lowXmode;

    // for MouseListener
    public boolean pressedToDrag=false;
    // for key listener
    protected boolean isCtrlDown=false;
    protected boolean isAltDown=false;
    protected boolean isShiftDown=false;
    // Zoom Cursor
    protected Cursor zoom;
    protected Cursor dezoom;

    public double actualScale=1;
    public double zoomOriginX=0;
    public double zoomOriginY=0;
    public boolean resize=false;
    
    // origin of picture
    // 
    public double originX=0;
    public double originY=0;
    public double relOriginX=0; // unitlength
    public double relOriginY=0; // unitlength
    public double originH;
    public double originW;
    public boolean drawRep=true;
    public double posSurfRepX;
    public double posSurfRepY;

    // Special Snap When special Key is pressed
    public double oldposX;
    public double oldposY;

    

    public SurfaceDessin() {
	super();
	setLayout(null);  // placement absolu
	setPreferredSize(new Dimension(500,450));
	addMouseMotionListener(this);
	addMouseListener(this);
	addKeyListener(this);
	manager=new ObjetManager();
	msgStatus=new String[20];
	/*
	try {
	    ImageIcon zp,zm;
	    Toolkit.getDefaultToolkit().getBestCursorSize(22, 22);
	    Toolkit.getDefaultToolkit().getMaximumCursorColors();


	    

	    if (!isApplet) {
		zp = new ImageIcon("images/ZoomIn24.gif");
		zm = new ImageIcon("images/ZoomOut24.gif");
	    } else {
		URL location; 
		location = JasToolbar.class.getResource("images/ZoomIn24.gif");
		zp = new ImageIcon(location);
		location = JasToolbar.class.getResource("images/ZoomOut24.gif");
		zm = new ImageIcon(location);
	    }
	    zoom=Toolkit.getDefaultToolkit().createCustomCursor(zp.getImage(), new Point(1,1),"zoomplus");
	    dezoom=Toolkit.getDefaultToolkit().createCustomCursor(zm.getImage(), new Point(1,1),"zoomminus");
	} catch (IndexOutOfBoundsException e) {
	    System.out.println("Error hotSpot");
	}
	*/
	//defaultC=zoom;
	initialisingMode();
	//setAutoscrolls(true);
    }

    public void setApplet(boolean b){ isApplet=b; }

    public void initialisingMode(){

	if (Configuration.antialiasing.equals("off")) _ANTIALIASING=false;
	else _ANTIALIASING=true;

	if (Configuration.modedebug.equals("on")) _DEBUG=true;
	else _DEBUG=false;

	if (Configuration.magneticGrid.equals("off")) _MAGNETIC=false;
	else _MAGNETIC=true;
	
	if (Configuration.snapToGrid.equals("on")) snapToGrid=true;
	else snapToGrid=false;

	if (Configuration.lowXServerMode.equals("off")) lowXmode=false;
	else lowXmode=true;

	tailleGrille=manager.getFirstProp().unitLength2Internal(Configuration.tailleGrille);

	msgStatus[0]=Languages.status_bar[0]; //"Choose the starting Node for the curve";
	msgStatus[1]=Languages.status_bar[1]; //"Choose the destination Node for the curve";
	msgStatus[2]=Languages.status_bar[2]; //"Set the Control point of the curve";
	msgStatus[3]=Languages.status_bar[3]; //"Set the first Control point of the curve";
	msgStatus[4]=Languages.status_bar[4]; //"Set the second Control point of the curve";
	msgStatus[5]=Languages.status_bar[5]; //"Choose a Node";
	msgStatus[6]=Languages.status_bar[6]; //" ";
	msgStatus[10]=Languages.status_bar[10]; //"Set the starting point of the curve";
	msgStatus[11]=Languages.status_bar[11]; //"Set the ending point of the curve";
	return;
    }

 
    public Point2D ajustMagnetic(double mx,double my){
	// implements the magnetic capabilities
	if (_MAGNETIC) {
	    mx=(double) (((int) ((mx+tailleGrille*Configuration.scale/2)/(tailleGrille*Configuration.scale)))
			 *tailleGrille*Configuration.scale);
	    my=(double) (((int) ((my+tailleGrille*Configuration.scale/2)/(tailleGrille*Configuration.scale)))
			 *tailleGrille*Configuration.scale);
	}
	return new Point2D.Double(mx,my);
    }

    public Point2D ajustMagnetic(double mx,double my,JasObject jo){
	// implements the magnetic capabilities
	if (_MAGNETIC) {
	    jo.deprecated_setULX((int) (mx/tailleGrille+0.5)*Configuration.tailleGrille);
	    jo.deprecated_setULY((int) -(my/tailleGrille+0.5)*Configuration.tailleGrille);
	    //System.out.println(jo.getULX()+" "+jo.getULY());
	}
	return (ajustMagnetic(mx,my));
    }
 

    protected void paintComponent(Graphics g) {
	Graphics2D g2 = (Graphics2D)g;
	if (firstime) { 
	    gRefLabel=g2;
	    firstime=false;
	}
	
	//g2.scale(actualScale,actualScale);
	
	//g2.translate(zoomOriginX,zoomOriginY);
	//if(resize){
	    //setSize((int) (500*Configuration.scale),
	    //    (int) (450*Configuration.scale));
	//setPreferredSize(new Dimension((int) (500*Configuration.scale),(int) (450*Configuration.scale)));
	//  resize=false;
	//}
	g.setColor(Color.white);
	g.fillRect(0, 0, getSize().width, getSize().height);
	
	//	if (select) manager.drawAreaSelected(g2);
	if(drawRep){
	    BasicStroke simple = new BasicStroke(1,
						 BasicStroke.CAP_BUTT,
						 BasicStroke.JOIN_BEVEL,
						 0,   // Miter limit
						 new float[] {4,4},
						 0);
	    g2.setStroke(simple);
	    g.setColor(new Color(150,150,150));
	    g.drawLine((int) (getRelativeCoordsOriginX()*tailleGrille+0.5),0,
		       (int) (getRelativeCoordsOriginX()*tailleGrille+0.5),(int) getHeight());
	    g.drawLine(0,(int) (getRelativeCoordsOriginY()*tailleGrille+0.5),
		       (int) (getWidth()),(int)(getRelativeCoordsOriginY()*tailleGrille+0.5));
	    g2.setStroke(new BasicStroke());
	    
	    g.setColor(Color.red);
	    g.drawLine((int) (getRelativeCoordsOriginX()*tailleGrille-5+0.5),
		       (int) (getRelativeCoordsOriginY()*tailleGrille+0.5),
		       (int) (getRelativeCoordsOriginX()*tailleGrille+5+0.5),
		       (int) (getRelativeCoordsOriginY()*tailleGrille+0.5));
	    
	    g.drawLine((int) (getRelativeCoordsOriginX()*tailleGrille+0.5),
		       (int) (getRelativeCoordsOriginY()*tailleGrille-5+0.5),
		       (int) (getRelativeCoordsOriginX()*tailleGrille+0.5),
		       (int) (getRelativeCoordsOriginY()*tailleGrille+5+0.5));
	}
	g.setColor(Color.black);
	dessineGrille(g2);

	if (_ANTIALIASING) 
	    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
	manager.drawAllObject(g);
	dessineDrag(g2);
	if (_ANTIALIASING) 
	    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
	// debugg -- start here
	if(_DEBUG) {
	    if (oldRedrawZone!=null)
		g2.draw(oldRedrawZone);
	    if (newRedrawZone!=null){
		g.setColor(Color.red);
		g2.draw(newRedrawZone);
	    }
	}
	// --------- fin
	

    }

    

    // method to paint the grid
    public void dessineGrille(Graphics2D g) {
	
	int largeur = getSize().width;
	int hauteur = getSize().height;
	int maxi    = (int)(largeur/(tailleGrille*Configuration.scale));
	int maxj    = (int)(hauteur/(tailleGrille*Configuration.scale));	
	int  ri, rj;

	for (int i=0; i<=maxi; i++) {
	    for (int j=0; j<=maxj; j++) {
		ri = (int)(tailleGrille*i*Configuration.scale);
		rj = (int)(tailleGrille*j*Configuration.scale);
		g.drawLine(ri, rj, ri, rj);
	    }
	}
	//g.drawLine(670,0,670,600); 
	// c'est la limite max du cadre. Si on veut aller plus loin, on doit redefinir les marges de tex.
    }

    public void dessineDrag(Graphics2D g) {
	if(!isSelecting) return;
	if((coteX=surfX-dragX)>0){
	    supleX=dragX;
	} else {
	    coteX=-coteX;
	    supleX=surfX;
	}
	if((coteY=surfY-dragY)>0){
	    supleY=dragY;
	} else {
	    coteY=-coteY;
	    supleY=surfY;
	}
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g.setStroke(simple);
	g.setColor(Color.blue);
	g.drawRect(supleX, supleY, coteX, coteY);
    }

    public void getDragRectangle() {
	// this method is just calculating the dragging rectangle.
	if(!isSelecting) return;
	if((coteX=surfX-dragX)>0){
	    supleX=dragX;
	} else {
	    coteX=-coteX;
	    supleX=surfX;
	}
	if((coteY=surfY-dragY)>0){
	    supleY=dragY;
	} else {
	    coteY=-coteY;
	    supleY=surfY;
	}
	
    }



    public void setItemToDraw(int itemnb) {
	// 0 = rond ...
	// 1 = ...
	// 10 = miniBox
	// TODO : fix the convention
	defaultitem=itemnb;
	// -> DEPRECIATED since version 1.7
	// DO NOT USE IT
    }

    public void setItemToDraw(int type,int ref) {
	// type = 0 Node
	// type = 1 Edge

	// ref = 0 OvalNode
	//       1 RectangularNode
	//       2 Round Rectangular Node
	
	// ref = 0 Straight Edge
	//       1 Bezier Courbe
	//       2 Simple Courbe
	//       3 Boucle
	defaulttype=type;
	defaultitem=ref;
	// force the creation (Edge caracteristic)
	if(defaulttype==1 || defaulttype==2 || (defaulttype==3 && defaultitem>2)) 
	    manager.addObject(defaulttype,defaultitem);
	else {
	    manager.reset2NodeMode();
	    repaint();
	}
	setMessage();
    }

    public void setItemToDrawReset(int type,int ref) {
	// this allow to cancel the autocreate mode
	defaulttype=-1;
	defaultitem=-1;
    }






    public void mouseDragged(MouseEvent e) {
	// System.out.println("Drag");
	// because CLICK=PRESSED+RELEASE+CLICK
	// to detect a dragging Event
	pressedToDrag=true;

	JasObject jo;
	if (isDrag && ((manager.myObjectAt(indexObject)) instanceof Selection)){
	    // we are dragging a selectionBox
	} else {
	    // in other case, we have to remove the selection area if there is one
	    if(!dontDeleteSelection && manager.currentselect!=null){
		Rectangle oldRedrawZone_bis;
		oldRedrawZone_bis=manager.getInvalideRectangle(manager.currentselect); // a reecrire
		select=manager.removeAreaSelected(select);
		paintImmediately(oldRedrawZone_bis);
	    }
	}
	if (isDrag) {
	    jo=manager.myObjectAt(indexObject);
	    // We are effectively dragging an item
	    if (jo instanceof MiniBox){
		// the object has been modified , updating...
		((MiniBox) jo).updatingSelection();
	    }
	    
	    oldRedrawZone=manager.getInvalideRectangle(jo);
	    if (jo instanceof SimpleObjectE){
		//jo.savePos();
		((SimpleObject) jo).setPos(e.getX()-dragX,e.getY()-dragY);
	    } else if((jo instanceof Node || jo instanceof SimpleObjectN) 
		      && snapToGrid){
		// magnetic move
		Point2D snapPoint=ajustMagnetic(e.getX(),e.getY(),jo);
		jo.setPos((int) snapPoint.getX(),(int) snapPoint.getY());
	    }
	    else {
		// CONVERTING - Special Snap
		Point2D speSnapP=specialSnap(e.getX(),e.getY());
		// END CONVERTING
		jo.setPos((int)speSnapP.getX(),(int)speSnapP.getY());
	    }
	    newRedrawZone=manager.getInvalideRectangle(jo);
	    paintOptimized(); // is wrong maybe ---> I think the rectangle is not clairly defined
	} else {
	    // We decide to select an area
	    getDragRectangle(); // calculate old rectangle
	    oldRedrawZone.setRect(supleX, supleY, coteX+2, coteY+2); // +2 coorect some bounds bug
	    surfX=e.getX();
	    surfY=e.getY();
	    getDragRectangle();
	    newRedrawZone.setRect(supleX, supleY, coteX+2, coteY+2);
	    paintOptimized();
	}

    }
    public void mousePressed(MouseEvent e) {
	// System.out.println("Pressed");
	//System.out.println(editingText);
	if(editingText){
	    //nlabel
	    nlabel.updatingWhenMove(tooBox,manager);
	}


	JasObject jo;
	dragX=e.getX();
	dragY=e.getY();
	oldposX=e.getX();
	oldposY=e.getY();
	if (indexObject!=-1) {
	    (jo=manager.myObjectAt(indexObject)).savePos();
	    if (jo instanceof SelectBox){
		((SelectBox) jo).setOffset(dragX,dragY);
	    }
	    if (jo instanceof MiniBox){
		dontDeleteSelection=true; // do not delete the MiniBox when dragging
		Point2D ptemp=((MiniBox) jo).getRelativeMB();
		oldposX=ptemp.getX();
		oldposY=ptemp.getY();
	    }
	    if (jo instanceof NodeLabel){
		// cannot replace or moving a Label directly
		isSelecting=true;
		newRedrawZone=new Rectangle();
		oldRedrawZone=new Rectangle();
	    } else {
		isDrag=true;    // We are now ready to drag		
	    }
	} else {
	    isSelecting=true;
	    timestamp=e.getWhen();
	    newRedrawZone=new Rectangle();
	    oldRedrawZone=new Rectangle();
	}
    }
    public void mouseReleased(MouseEvent e) {
	// System.out.println("Released");
	JasObject jo=null;

	//if(manager.currentselect!=null){
	//  System.out.println(manager.currentselect);

	    //}

	if(!pressedToDrag){
	    // simply a click event
	    isDrag=false;
	    dontDeleteSelection=false;
	    isSelecting=false;
	    // stop goto click handle.
	    return;
	} else {
	    // unlock the dragging
	    pressedToDrag=false;
	}

	if (isDrag) {
	    // this test is for dragging a simple object
	    // such as a node.
	    jo=manager.myObjectAt(indexObject);
	    if (jo instanceof SelectBox){
		Point p=((SelectBox) jo).returnDeplacement();
		Point2D p2=ajustMagnetic(p.getX(),p.getY(),jo);
		jo.setPos((int) (e.getX()-(p.getX()-p2.getX())),
			  (int) (e.getY()-(p.getY()-p2.getY())));
		manager.moveSelectedObject((int) p2.getX(),(int) p2.getY());
	    }
	    //if (jo instanceof Selection){
		// correct a miniBox bug
	    // BUT IT DON T WORK
	    //((Selection) jo).updatingSelection();
	    //}
	}

	if (isSelecting) {
	    // this tests for creating a new selection area
	    // if a selection already exists, the old selection
	    // is normaly deleted in the dragging handle.

	    // select=manager.removeAreaSelected(select); // noneed anymore

	    if((e.getWhen())-timestamp<90 && isApplet){
		// added for sensitivity Applet	
		// 90 is a raisonable number
		isSelecting=false;
		isDrag=false;
		dontDeleteSelection=false;
		// simulating a click
		mouseClicked(e);
		// stop here
		return;
	    } else {
		// in the other case, creates the new selection
		if(manager.selectArea(supleX,supleY,coteX,coteY)) {
		    //System.out.println("Creating Selection SECTION 1");
		    select=true;
		}
	    }
	    isSelecting=false;
	    repaint(); // TODO optimizing
	}


	if (isDrag) {
	    if (jo instanceof ANode) {
		//MAGNETIC SYSTEM
		Point2D pointed = ajustMagnetic(jo.deprecated_getX(),jo.deprecated_getY(),jo);
		jo.setPos((int)pointed.getX(),(int)pointed.getY());
	    } else if (jo instanceof MiniBox) {
		//System.out.println("readjusting MiniBox");
		//((MiniBox) jo).updatingSelection();
		((MiniBox) jo).reAdjustFromFake();
		
	    }
	    //System.out.println(jo);
	    updatingWhenMove(jo);
	    repaint();
	}

	isDrag=false;
	dontDeleteSelection=false;	
    }

    public void mouseClicked(MouseEvent e) {
	//System.out.println("Click");
	JasObject jo;
	surfX=e.getX();
	surfY=e.getY();
	
	// mouse buttons
	boolean isleftbutton=SwingUtilities.isLeftMouseButton(e);
	boolean isrightbutton=SwingUtilities.isRightMouseButton(e);
	
	if (isAltDown) {
	    isleftbutton=false;
	    isrightbutton=true;
	} 

	/* else if(isCtrlDown) {
	   if(Configuration.scale!=1){
	   Configuration.scale--;
	   //zoomOriginX+=50;
	   actualScale=Configuration.scale;
	   resize=true;
	   //actualScale-=1;
	   select=manager.removeAreaSelected(select);
	   repaint();
	   
	   }
	   return;
	   } else if(isShiftDown) {
	   Configuration.scale++;
	   //zoomOriginX-=50;
	   actualScale=Configuration.scale;
	   resize=true;
	   //actualScale+=1;
	   select=manager.removeAreaSelected(select);
	   repaint();
	   return;
	   }
	*/
	
	// at this time, the selection has not been removed.
	if(indexObject!=-1){
	    // the mouse is on an JasObject
	    indexObject=manager.nearestObject(surfX,surfY);
	    jo=manager.myObjectAt(indexObject);
	    /*
	    if (jo instanceof SelectNodeLabel){
		// case of NodeLabel
		// setting :  carret section (Text Modifier)
		if (!(((SelectNodeLabel) jo).jlb.editable())) return;
		Point2D origin = ((SelectNodeLabel) jo).jlb.layoutOrigin;
		float clickX = (float) (e.getX() - origin.getX());
		float clickY = (float) (e.getY() - origin.getY());
		
		TextHitInfo currentHit = 
		    ((SelectNodeLabel) jo).jlb.getActualLayout().hitTestChar(
									     clickX, 
									     clickY);
		insertionIndex = currentHit.getInsertionIndex();
		((SelectNodeLabel) jo).setCarretIndex(insertionIndex);
		repaint();
		editingText=true;
		ttCode=((SelectNodeLabel) jo).jlb.getActualLayout();
		nlabel=((SelectNodeLabel) jo).jlb;
		return;
		
	    } else if (jo instanceof SelectEdgeLabel){
		if (!(((SelectEdgeLabel) jo).jlb.editable())) return;
		Point2D origin = ((SelectNodeLabel) jo).jlb.layoutOrigin;
		float clickX = (float) (e.getX() - origin.getX());
		float clickY = (float) (e.getY() - origin.getY());
		
		TextHitInfo currentHit = 
		    ((SelectEdgeLabel) jo).jlb.getActualLayout().hitTestChar(
									     clickX, 
									     clickY);
		return;
	    }
	    */

	    // IJasTextEdit
	    if (jo instanceof IJasTextEdit){
		//System.out.println("Ohoho");
		IJasTextEdit iedit=(IJasTextEdit) jo;
		if(!iedit.isEditable()) return;
		Point2D origin = iedit.getLayoutOrigin();
		float clickX = (float) (e.getX() - origin.getX());
		float clickY = (float) (e.getY() - origin.getY());
		TextHitInfo currentHit = 
		    iedit.getActualLayout().hitTestChar(clickX,clickY);
		insertionIndex = currentHit.getInsertionIndex();
		iedit.setCarretIndex(insertionIndex);
		repaint();
		editingText=true;
		ttCode=iedit.getActualLayout();
		nlabel=iedit.getNEL();
		return;
	    }


	    if (isrightbutton){
		// if jo a selection
		if (jo instanceof Selection){
		    collection=(Vector) manager.getSelectedObject().clone();
		    selectCenter=((SelectBox)jo).getCenter();
		}
		// context menu of this object
		posSurfRepX=surfX;
		posSurfRepY=surfY;
		ocmenu.showPopup(true,surfX,surfY,manager.myObjectAt(indexObject));
		// keep the selection active
		return;
	    }
	} else {
	    // case no object is pointed.
	    if (isrightbutton){
		// context menu
		posSurfRepX=surfX;
		posSurfRepY=surfY;
		ocmenu.showPopup(true,surfX,surfY,null);
		// keep the selection active
		return;
	    }
	}
	

	// resetting text modifier
	editingText=false;

 	select=manager.removeAreaSelected(select); // remove select
	indexObject=manager.nearestObject(surfX,surfY);
	
	if(isleftbutton && switchingMode(surfX ,surfY)) {
	    if(indexObject==-1){
		//MAGNETIC
		if(defaulttype!=-1 && defaultitem!=-1) {
		    JasObject jo2;
		    
		    // the Configuration.scale parameter is needed for zoom 
		    jo2=manager.addObject(defaulttype,defaultitem);
		    Point2D pointed = ajustMagnetic((double) e.getX(),
						    (double) e.getY(),jo2);
		    jo2.setPos((int)pointed.getX(),(int)pointed.getY());
		}
	    }
	    else {
		if(manager.selectArea(indexObject)) {
		    select=true;
		    // temporaire
		    jo=manager.myObjectAt(indexObject);
		    // set for redrawing after updating in toolbox
		    oldRedrawZone=manager.getInvalideRectangle(jo);
		    tooBox.send2Toolbox(jo,this);
		}
		else {
		    select=false;
		    indexObject=manager.nearestObject(surfX,surfY);
		}
	    }
	    repaint(); // TODO Optimizing
	}
	       
	// if clicked and item is "selectable" then create the MiniBox
	/*
	if(SwingUtilities.isRightMouseButton(e)){
	    if (indexObject!=-1) {
		indexObject=manager.nearestObject(surfX,surfY);
		ocmenu.showPopup(true,surfX,surfY,manager.myObjectAt(indexObject));
	    } else 
		ocmenu.showPopup(true,surfX,surfY,null);
		}*/

	setMessage();
	repaint();
    }


    public void mouseMoved(MouseEvent e) {
	surfX=e.getX();
	surfY=e.getY();
	if(isCtrlDown){
	    statusBar.setText(surfX+","+surfY);
	}
	Cursor tmp;
	if (!isDrag) {
	    indexObject=manager.nearestObject(surfX,surfY);
	    //if (indexObject!=-1) System.out.println("BOX " + indexObject);
	}
	if(!isSelecting && indexObject!=-1){
	    if ((tmp=(manager.myObjectAt(indexObject)).getCursor())!=null){
		setCursor(tmp);
	    } else {
		setCursor(handC);
	    }
	}
	else setCursor(defaultC);
	//System.out.println(manager.countObject()+" "+indexObject);
    }





    /**
     * Methodes inutiles pour l'instant
     * (Implementation de l'interface MouseListener)
     */
    public void mouseEntered(MouseEvent e) { requestFocus(); }
    public void mouseExited(MouseEvent e) {}

    public void paintOptimized(){
	if(lowXmode){
	    if(oldRedrawZone.intersects(newRedrawZone)){
		paintImmediately(newRedrawZone.union(oldRedrawZone)); 
	    }
	    else{
		paintImmediately(oldRedrawZone);
		paintImmediately(newRedrawZone);
	    }
	} else { repaint(); }

    }

    public void setToolBox(JasObjectToolBox jtb){
	tooBox=jtb;
	manager.tb=jtb;
    }

    public void setAntiAliasing(boolean b) {
	_ANTIALIASING=b;
    }

    public void setMagnetic(boolean b) {
	_MAGNETIC=b;
    }
    public static boolean isMagnetic() {
	return _MAGNETIC;
    }
    public void refreshNewAddedObject(JasObject jo){
	manager.refreshNew(jo);
    }

    public void fromToolBoxRefresh(JasObject jo){
	// this method is valid for only one element selected
	// and being modified by the toolbox
	// manager.selectArea(manager.indexObject(jo));

	Rectangle oldRedrawZone_bis,rtemp;

	if(manager.currentselect==null) {
            manager.selectArea(manager.indexObject(jo));
            select=true;
        }

	// this part delete the old SelectBox
	oldRedrawZone_bis=manager.getInvalideRectangle(manager.currentselect); // a reecrire
	select=manager.removeAreaSelected(select);
	paintImmediately(oldRedrawZone_bis);

	// define a new selection Box
	manager.selectArea(manager.indexObject(jo));
	select=true;
	newRedrawZone=manager.getInvalideRectangle(jo);
	// get the new select Box bounds
	rtemp=manager.getInvalideRectangle(manager.currentselect);
	// Union of the two rectangles
	newRedrawZone.add(rtemp);
	paintOptimized();
    }

    public void fromContextRefresh(JasObject jo){
	newRedrawZone=manager.getInvalideRectangle(jo);
	paintOptimized();
    }

    public void setContextMenu(ObjectControlMenu menu){
	ocmenu=menu;
    }

    public boolean switchingMode(int px , int py){
	// required a click event
	// returns true if no special mode is selected
	// false in other cases
	JasObject jo;
	int rmode=manager.getMode();

	//System.out.println("Mode = "+rmode);
	if (rmode==0) return true;
	if (indexObject!=-1){
	    jo=manager.myObjectAt(indexObject);
	    if (jo instanceof AEdge || jo instanceof INELabel) return true;
	}

	if(manager.addPointZone(px,py,this)){
	    // setinf defaluts	    
	    setItemToDraw(0,0);
	}
	return false;
    }

    public Graphics2D getSurfaceDGraphics(){
	return gRefLabel;
    }

    public String getLatexCode() {
	return manager.getAllGastexCode(getRelativeCoordsOriginX()*
					Configuration.tailleGrille,
					-getRelativeCoordsOriginY()*
					Configuration.tailleGrille);
    }

    private void updatingWhenMove(JasObject jo){
	// DONE Deported
	// sous forme de fonction :
	// abstract UpdatingWhenMove(JasToolBox,ObjetManager)
	if (!(jo instanceof Selection || jo instanceof MiniBox)) {
	    tooBox.send2Toolbox(jo,this);
	}
	jo.updatingWhenMove(tooBox,manager);
	//System.out.println(jo);
    }

    public void setStatusBar(JLabel statusBar){
	this.statusBar=statusBar;
    }

    public void setMessage(){
	int mi=manager.getMsgIndex();
	if (mi != -1)
	    statusBar.setText(msgStatus[mi]);
    }





    // ** KEY LISTENER HERE
    
    public void keyPressed(KeyEvent e){
	int keyCode = e.getKeyCode();
	//System.out.println(e.getKeyCode());
	if(editingText) {
	    // only if editting text
	    if (keyCode == KeyEvent.VK_LEFT || keyCode == KeyEvent.VK_RIGHT) {
		ttCode=nlabel.getActualLayout();
		handleArrowKey(keyCode == KeyEvent.VK_RIGHT);
		return;
	    }
	    //int r=keyCode-KeyEvent.VK_A+'a';
	    //nlabel.editTextInsert((char) r);
       	    //repaint();
	    //ttCode=nlabel.getActualLayout();
	}
	if(keyCode==KeyEvent.VK_CONTROL) isCtrlDown=true;
	else if(keyCode==KeyEvent.VK_ALT) isAltDown=true;
	else if (keyCode==KeyEvent.VK_SHIFT) isShiftDown=true;

    }

    public void keyReleased(KeyEvent e){
	isCtrlDown=false;
	isAltDown=false;
	isShiftDown=false;
    }
    public void keyTyped(KeyEvent e){
	KeyStroke kt=KeyStroke.getKeyStrokeForEvent(e);
	//System.out.println((int) kt.getKeyChar());
	char strokechar=kt.getKeyChar();
	if(editingText) {
	    if((int) strokechar>=32 && (int) strokechar!=127){
		nlabel.editTextInsert(strokechar);
		//repaint();
		//ttCode=nlabel.getActualLayout();
	    } else {
		// particular case
		// cariage retuen = 10
		// suppr = 127
		// backspace = 8
		switch((int) strokechar) {
		case 127:
		    nlabel.suppr(0);
		    break;
		case 8:
		    nlabel.suppr(1);
		    break;	
		}
	    }
	    repaint();
	    ttCode=nlabel.getActualLayout();
	    return;
	}
	// ** other case
	JasObject jo;
	switch((int) strokechar) {
	case 127:
	    if (manager.currentselect!=null && manager.currentselect instanceof SelectBox) {	
		//System.out.println("SelectBoxdetected");
		if(manager.getNumberSelectedObject()==1){
		    rmvDefinitivelyObject(manager. getFirstSelectedObject());
		    select=manager.removeAreaSelected(select);
		    repaint();
		    return;
		} else {
		    manager.rmvDefinitivelySelection();
		    select=manager.removeAreaSelected(select);
		    repaint();
		}
	    } else {
		rmvDefinitivelyObject(manager. getFirstSelectedObject());
		select=manager.removeAreaSelected(select);
		repaint();
	    }
	    break;
	case 3:
	    copy();
	    break;
	case 22:
	    paste(true);
	    break;
	case 1: // CTRL+A
	    selectAll();
	    break;
	case 24: // CTRL + X
	    copy();
	    deleteZone();
	    break;
	case 45: // "-" ZOOM
	    if(Configuration.scale!=1){
		Configuration.scale--;
		//zoomOriginX+=50;
		actualScale=Configuration.scale;
		resize=true;
		//actualScale-=1;
		select=manager.removeAreaSelected(select);
		setPreferredSize(new Dimension((int)(500*actualScale),
					       (int)(450*actualScale)));
		revalidate();
		repaint();
	    }
	    break;	
	case 43: // "+" ZOOM
	    Configuration.scale++;
	    //zoomOriginX-=50;
	    actualScale=Configuration.scale;
	    resize=true;
	    //actualScale+=1;
	    select=manager.removeAreaSelected(select);
	    setPreferredSize(new Dimension((int)(500*actualScale),
					   (int)(450*actualScale)));
	    revalidate();
	    repaint();
	    break;
	}
	//System.out.println((int) strokechar);
    }
       


    // ** KEY FUNCTION
    private void handleArrowKey(boolean rightArrow) {
	TextHitInfo newPosition;
	if (rightArrow) {
	    newPosition = 
		 ttCode.getNextRightHit(nlabel.getOldIndex());
	}
	else {
	    newPosition = 
		 ttCode.getNextLeftHit(nlabel.getOldIndex());
	}
	
	if (newPosition != null) {
	    nlabel.setInsertionIndex( newPosition.getInsertionIndex());
	    repaint();
	}
    }


    public void rmvDefinitivelyObject(JasObject comp){
	manager.rmvDefinitivelyObject(comp,this);
    }


    public void copy (Vector selectedObjects) {
	int sz = selectedObjects.size();
	int index2 = sz;
	copyPaste = new Vector();
	copyPaste.setSize(sz);
	for(int i = 0; i < sz; i++) {
	    Object o = selectedObjects.elementAt(i);
	    if (o instanceof ANode) {
		if (copyPaste.elementAt(i) == null) {
		    //only if it hasn't been cloned yet
		    copyPaste.setElementAt(((ANode) o).clone(), i);
		}
	    } else if ((o instanceof SimpleObjectN)) {
		copyPaste.setElementAt(((JasObject) o).clone(), i);
	    } else if ((o instanceof AEdge)
		       && !(o instanceof IFMark)
		       && !(o instanceof SimpleObjectE)) {
		AEdge ae = (AEdge) o;
		ANode sn = ae.getStartingNode();
		ANode en = ae.getEndingNode();
		//check if the nodes of the edge have been cloned
		ANode csn = null;
		ANode cen = null;
		int indexSn = selectedObjects.indexOf(sn);
		int indexEn = selectedObjects.indexOf(en);
		//loop have en == sn so indexSn and indexEn have the same value
		if (indexSn != -1 && indexEn != -1) {
		    if ((csn = (ANode)copyPaste.elementAt(indexSn)) == null) {
			//only if it hasn't been cloned yet
			csn = (ANode) sn.clone();
			copyPaste.setElementAt(csn, indexSn);
		    } //else it was already cloned
		    if ((cen = (ANode)copyPaste.elementAt(indexEn)) == null) {
			//only if it hasn't been cloned yet
			cen = (ANode) en.clone();
			copyPaste.setElementAt(cen, indexEn);
		    } //else it was already cloned
			copyPaste.setElementAt(ae.clone(csn,cen), i);
			
		} //else the edge is not complete
	    } else if ((o instanceof AEdge) &&
		       (o instanceof SimpleObjectE)) {
		AEdge ae = (AEdge) o;
		ANode csn = (ANode) ae.getStartingNode().clone();
		ANode cen = (ANode) ae.getEndingNode().clone();
// 		copyPaste.setElementAt( csn,index2++);
// 		copyPaste.setElementAt(cen, index2++);
		copyPaste.setElementAt(ae.clone(csn, cen), i);
	    }
	}
	//erase all the null elements if needed
	while(copyPaste.remove(null));
    }
	
    
    public void copy(JasObject comp){
	if(!(comp instanceof Selection)){
	    collection=null;
	    //nedd to build a vector to call the other copy
	    Vector object = new Vector();
	    object.add((JasObject) comp.clone());
	    copy(object);
	} else {
	    copy(collection);
	}
    }
// 	    copyPaste = new Vector();
// 	    copyPaste.add((JasObject) comp.clone());

    public void paste(boolean btn){
	// TODO : To optimize just for test
	
	select=manager.removeAreaSelected(select);

	if (copyPaste==null) return;
	int sz = copyPaste.size();
	if (sz==0) return;
	

	//
	//	copyPaste.setPos(surfX,surfY);
	if (sz == 1) {
	    JasObject comp = (JasObject) copyPaste.firstElement();
	    if (comp instanceof IFMark) {
		IFMark ifm = (IFMark) comp;
		ANode n = ifm.getNode();
		IFMark cifm = (IFMark) ifm.clone(n);
		n.addIFmark(cifm);
		manager.refreshNew(n);
	    } else if (comp instanceof RMark) {
		RMark rm = (RMark) comp;
		ANode n = rm.getNode();
		RMark crm = (RMark) rm.clone(n);
		n.addRmark(crm);
		manager.refreshNew(n);
	    } else {
		Point2D pointed = ajustMagnetic(surfX,surfY,comp);
		comp.setPos((int)pointed.getX(),(int)pointed.getY());
		manager.addObject(comp);
	    }
	} else {
	    Point2D pointed=null;
	    if(!btn){
		pointed = ajustMagnetic(surfX-selectCenter.getX(),surfY-selectCenter.getY());
		selectCenter=new Point(surfX,surfY);
	    }else {
		int dx=getSize().width/2;
		int dy=getSize().height/2;
		pointed = ajustMagnetic(dx-selectCenter.getX(),dy-selectCenter.getY());
		selectCenter=new Point(dx,dy);
	    }
	    Point pt= new Point((int)pointed.getX(),(int)pointed.getY());
	    //selectCenter=new Point(surfX,surfY);
	    manager.addObject(copyPaste,pt);
	    select=true;
	    
	    paintComponent(gRefLabel);
	    //repaint(0,0,0,getSize().width,getSize().height);
	    manager.reSelectSelection();
	}
	copy(copyPaste);  //<< next duplication
	repaint();
    }

    public ObjetManager getManager(){
	return manager;
    }

    public void rmvDefinitivelyObject(){
	if (manager.currentselect!=null && manager.currentselect instanceof SelectBox) {	
	    System.out.println("SelectBoxdetected");
	    if(manager.getNumberSelectedObject()==1){
		rmvDefinitivelyObject(manager. getFirstSelectedObject());
		select=manager.removeAreaSelected(select);
		repaint();
		return;
	    } else {
		manager.rmvDefinitivelySelection();
		select=manager.removeAreaSelected(select);
		repaint();
	    }
	} else {
	    rmvDefinitivelyObject(manager. getFirstSelectedObject());
	    select=manager.removeAreaSelected(select);
	    repaint();
	}
    }

    
    public void copy(){
	if (manager.currentselect!=null && manager.currentselect instanceof SelectBox){
	    collection=(Vector) manager.getSelectedObject().clone();
	    selectCenter=((SelectBox)manager.currentselect).getCenter();
	    copy(manager.currentselect);//getSelectedObject());
	}
    }


    public int convertZoom(int param){
	// Warning , unit in Pixel
	if (Configuration.scale==0) return param;
	return (int) (param/Configuration.scale);
    }

    public boolean getSlide(){
	return manager.getSlide();
    }

    public boolean isThereAnyObjects(){
	return !manager.isSFEmpty();
    }

    public void deleteZone(){
	getManager().rmvDefinitivelySelection();
	select=getManager().removeAreaSelected(select);
	repaint();
    }

    public void selectAll(){
	//deleteZone();
	select=getManager().removeAreaSelected(select);
	manager.indexSelectedObject.clear();
	manager.indexSelectedObject=(Vector) manager.allobject.clone();
	//System.out.println("fdsdf---"+manager.indexSelectedObject.size());
	manager.reSelectSelection();
	repaint();
	dontDeleteSelection=false; select=true;
    }

    public Point2D getRelativeCoords(Point2D p){
	// Warning do not use it to set values into JasObjects
	// Warning all in unitlength
	return (new Point2D.Double(p.getX()-relOriginX,
				   p.getY()-relOriginY));
    }

    public Point2D getRealCoords(Point2D p){
	// same warning as above
	return (new Point2D.Double(p.getX()+relOriginX,
				   p.getY()+relOriginY));
    }

    public Point2D getRelativeCoords(double px, double py){
	// Warning do not use it to set values into JasObjects
	// Warning all in unitlength
	return (getRelativeCoords(new Point2D.Double(px,py)));
    }

    public Point2D getRealCoords(double px, double py){
	// Warning do not use it to set values into JasObjects
	// Warning all in unitlength
	return (getRealCoords(new Point2D.Double(px,py)));
    }

    public void setRelativeCoordsOrigin(double px,double py){
	relOriginX=px;
	relOriginY=py;
    }

    public void setRelativeCoordsOriginSurf(){
	setRelativeCoordsOrigin((int) (posSurfRepX/tailleGrille+0.5),(int) (posSurfRepY/tailleGrille+0.5));
    }

    public double getRelativeCoordsOriginX(){ return relOriginX; }
    public double getRelativeCoordsOriginY(){ return relOriginY; }

    public void updateScale(){
	Configuration.scale=(int) actualScale;
    }

    public void setScale(int factor){
	actualScale=factor;
    }

    public Point2D specialSnap(double sx,double sy){
	if(isShiftDown) {
	    if(sx==oldposX && sy==oldposY) return (new Point2D.Double(sx,sy));
	    if(sx==oldposX) return (new Point2D.Double(sx,sy));
	    double sign=(oldposX<sx)?0:1;
	    double sign2=(oldposY>sy)?1:-1;
	    double alpha=Math.atan((oldposY-sy)/(sx-oldposX))+Math.PI*sign*sign2;
	    if (alpha<Math.PI/8 && alpha>-Math.PI/8){
		//System.out.println("OK1 "+alpha*180/Math.PI);
		return (new Point2D.Double(sx,oldposY));
	    } else if (alpha>Math.PI/8 && alpha<Math.PI/8*3){
		//System.out.println("OK2 "+alpha*180/Math.PI);
		return (new Point2D.Double(sx,-sx+oldposX+oldposY));
	    } else if (alpha>Math.PI/8*3 && alpha<Math.PI/8*5){
		//System.out.println("OK3 "+alpha*180/Math.PI);
		return (new Point2D.Double(oldposX,sy));
	    } else if (alpha>Math.PI/8*5 && alpha<Math.PI/8*7){
		//System.out.println("OK4 "+alpha*180/Math.PI);
		return (new Point2D.Double(sx,sx+oldposY-oldposX));
	    } else if (alpha>-Math.PI/8*3 && alpha<-Math.PI/8){
		//System.out.println("OK8 "+alpha*180/Math.PI);
		return (new Point2D.Double(sx,sx+oldposY-oldposX));
	    } else if (alpha>-Math.PI/8*5 && alpha<-Math.PI/8*3){
		//System.out.println("OK7 "+alpha*180/Math.PI);
		return (new Point2D.Double(oldposX,sy));
	    } else if (alpha>-Math.PI/8*7 && alpha<-Math.PI/8*5){
		//System.out.println("OK6 "+alpha*180/Math.PI);
		return (new Point2D.Double(sx,-sx+oldposX+oldposY));
	    } else {
		//System.out.println("OK5 "+alpha*180/Math.PI);
		return (new Point2D.Double(sx,oldposY));
	    }
	}
	return (new Point2D.Double(sx,sy));
    }
}








