package jastex.old.gui.tabs;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import jastex.*;
import jastex.old.obj.JasObject;
import jastex.old.obj.AEdge;


import jastex.gui.JasScrollBox;


public class JasLineOffsetTab extends OJasTab {
    
    public JasScrollBox sxo;
    public JasScrollBox syo;
    public JasScrollBox exo;
    public JasScrollBox eyo;
    

    /** Constructor : Instanciate a new Tab for the Line
     * @param title : the tab caption
     * @param object : the JasObject filling the Tab field
     */
    public JasLineOffsetTab(String title , JasObject object)
    {
	super(title,object);
	sxo = new JasScrollBox(((AEdge)object).getpsxo());
	syo = new JasScrollBox(((AEdge)object).getpsyo());
	exo = new JasScrollBox(((AEdge)object).getpexo());
	eyo = new JasScrollBox(((AEdge)object).getpeyo());
	
	insertPropertie(Languages.tb_offsetTab[0],sxo);
	insertPropertie(Languages.tb_offsetTab[1],syo);
	insertPropertie(Languages.tb_offsetTab[2],exo);
	insertPropertie(Languages.tb_offsetTab[3],eyo);
    }
    

    public JasLineOffsetTab(String title , GastexGlobalProperties myGgp)
    {
	super(title);
	sxo = new JasScrollBox(myGgp.getpsxo());
	syo = new JasScrollBox(myGgp.getpsyo());
	exo = new JasScrollBox(myGgp.getpexo());
	eyo = new JasScrollBox(myGgp.getpeyo());
	
	insertPropertie(Languages.tb_offsetTab[0],sxo);
	insertPropertie(Languages.tb_offsetTab[1],syo);
	insertPropertie(Languages.tb_offsetTab[2],exo);
	insertPropertie(Languages.tb_offsetTab[3],eyo);
    }
    

    public JasLineOffsetTab(String title , Vector objects)
    {
	super(title,objects);
	GastexGlobalProperties myGgp = ((JasObject)objects.firstElement()).getGgp();
	
    	sxo = new JasScrollBox(myGgp.getpsxo());
	syo = new JasScrollBox(myGgp.getpsyo());
	exo = new JasScrollBox(myGgp.getpexo());
	eyo = new JasScrollBox(myGgp.getpeyo());
	
	insertPropertie(Languages.tb_offsetTab[0],sxo);
	insertPropertie(Languages.tb_offsetTab[1],syo);
	insertPropertie(Languages.tb_offsetTab[2],exo);
	insertPropertie(Languages.tb_offsetTab[3],eyo);

    }

    public void saveGgp(GastexGlobalProperties ggp)
    {
	ggp.setpsxo(sxo.getValue());
	ggp.setpsyo(syo.getValue());
	ggp.setpexo(exo.getValue());
	ggp.setpeyo(eyo.getValue());
    }


    public void writeOffset(JasObject obj){
	((AEdge)obj).setpsxo(sxo.getValue());
	((AEdge)obj).setpsyo(syo.getValue());
	((AEdge)obj).setpexo(exo.getValue());
	((AEdge)obj).setpeyo(eyo.getValue());
    }
}
