/*
 * SelectBox.java
 *
 * Created on 6 mars 2005, 10:31
 */

package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



/**
 *
 * @author steph
 */
public class SelectBox extends Selection {

    public boolean redimensionnable=true;
    public Rectangle r;

    public Point p1;

    public Point p2;

    public Point p3;

    public Point p4;

    public MiniBox b1;

    public MiniBox b2;

    public MiniBox b3;

    public MiniBox b4;
    public MiniBox b5; // special nMr

    public int recX;

    public int recY;

    public int recW;

    public int recH;

    public int offsetx;

    public int offsety;
    public Node noeud=null;
    public boolean recadred=false;

    public int carreX;

    public int carreY;

    public int rondX;

    public int rondY;


    public SelectBox(){}

    public SelectBox(Rectangle rec){
	r=rec;
	recX=(int)(r.getX());
	recY=(int)(r.getY());
	recW=(int)(r.getWidth());
	recH=(int)(r.getHeight());
	miniB=new Vector();
	p1=new Point(recX,recY);
        p2=new Point(recX+recW,recY);
        p3=new Point(recX,recY+recH);
        p4=new Point(recX+recW,recY+recH);
	b1=new MiniBox(recX,recY);
	b2=new MiniBox(recX+recW,recY);
	b3=new MiniBox(recX,recY+recH);
	b4=new MiniBox(recX+recW,recY+recH);
	b5=new MiniBox();
	b1.savePos();
	b2.savePos();
	b3.savePos();
	b4.savePos();
	miniB.addElement(b1);
	miniB.addElement(b2);
	miniB.addElement(b3);
	miniB.addElement(b4);
	//miniB.addElement(b5);
	cursor=new Cursor(Cursor.MOVE_CURSOR);
	deprecated_x=(int)recX;
	deprecated_y=(int)recY;
	b1.cursor=new Cursor(Cursor.NW_RESIZE_CURSOR);
	b2.cursor=new Cursor(Cursor.NE_RESIZE_CURSOR);
	b3.cursor=new Cursor(Cursor.SW_RESIZE_CURSOR);
	b4.cursor=new Cursor(Cursor.SE_RESIZE_CURSOR);
	b5.cursor=new Cursor(Cursor.E_RESIZE_CURSOR);
	b1.setDepends(this);
	b2.setDepends(this);
	b3.setDepends(this);
	b4.setDepends(this);
	b5.setDepends(this);
    }

    public void setResizable(boolean b) {
	redimensionnable=b;
	Color col=b?Color.red:Color.orange;
	int i=miniB.size(),j=0;
	MiniBox btemp;
	while (j<i) {
	    btemp=(MiniBox) miniB.elementAt(j);
	    btemp.setSensitive(b);	    
	    btemp.setColor(col);
	    if(b) btemp.setInvisibleMode(true);
	    j++;
	}
	if (noeud instanceof Node){
	    //	    System.out.println("yp");
	    btemp=b5;
	    miniB.addElement(btemp);
	    btemp.setSensitive(b);	
	    btemp.setColor(new Color(37,155,106));
	    carreX=recX+5;//+recW+15;
	    carreY=recY+recH;
	    rondX=recX+recW-5;//+15;
	    rondY=recY+recH;
	    if(b) btemp.setInvisibleMode(true);
	    double inmr=((Node) noeud).getNmrPercent();
	    b5.setPos((int)(carreX+(rondX-carreX)*inmr),
		      (int)(carreY));//+(rondY-carreY)*inmr));
	    b5.setFakePos((int)(carreX+(rondX-carreX)*inmr),
			  (int)(carreY));//+(rondY-carreY)*inmr));
	    
	}
    }

    public double getMinDistanceDroite(Point pp1,Point pp2,Point p){
	Line2D.Double l=new Line2D.Double(pp1,pp2);
	return (l.ptSegDist(p));
    }

    public double getMinDistance(int gx,int gy){
	if (r.contains(gx,gy)) return 0.0;
	double minD,temp;
	Point p=new Point(gx,gy);
	minD=getMinDistanceDroite(p1,p2,p);
       	minD=((temp=getMinDistanceDroite(p2,p4,p))<minD)?temp:minD;
	minD=((temp=getMinDistanceDroite(p3,p4,p))<minD)?temp:minD;
	minD=((temp=getMinDistanceDroite(p3,p1,p))<minD)?temp:minD;
	return minD;
    }

    public void recadre(){
	double inmr=0;
	// repositionnig the miniBox
	b1.savePos();
	b2.savePos();
	b3.savePos();
	b4.savePos();

	b1.setPos(recX,recY);
	b2.setPos(recX+recW,recY);
	b3.setPos(recX,recY+recH);
	b4.setPos(recX+recW,recY+recH);

	//carreX=recX+recW+15;
	//carreY=recY;
	//rondX=recX+recW+15;
	//rondY=recY+recH;

	carreX=recX+5;//+recW+15;
	carreY=recY+recH;
	rondX=recX+recW-5;//+15;
	rondY=recY+recH;
	
	if (noeud instanceof Node){
	    inmr=((Node) noeud).getNmrPercent();
	    b5.setPos((int)(carreX+(rondX-carreX)*inmr),
		      (int)(carreY));//+(rondY-carreY)*inmr));
	    //b5.setPos((int)(carreX),
	    //(int)(carreY+(rondY-carreY)*inmr));
	}

	
	if(redimensionnable){
	    b1.setFakePos(recX,recY);
	    b2.setFakePos(recX+recW,recY);
	    b3.setFakePos(recX,recY+recH);
	    b4.setFakePos(recX+recW,recY+recH);
	    if (noeud instanceof Node){
		//b5.setFakePos((int)(carreX),
		//	      (int)(carreY+(rondY-carreY)*inmr));
		b5.setFakePos((int)(carreX+(rondX-carreX)*inmr),
			      (int)(carreY));//+(rondY-carreY)*inmr));
	    }
	}

	
    }
    public void setOffset(int posx,int posy) {
	offsetx=posx-deprecated_x;
	offsety=posy-deprecated_y;
    }

    public Point returnDeplacement() {
	return (new Point(deprecated_x-deprecated_oldx,deprecated_y-deprecated_oldy));
    }

    public void setPos(int posx,int posy) {
	// We have some offset
	deprecated_x=posx-offsetx; 
	deprecated_y=posy-offsety;
	// repositionnig the rectangle
	r.setLocation(deprecated_x,deprecated_y);
	recX=deprecated_x;
	recY=deprecated_y;
	recX=(int)(r.getX());
	recY=(int)(r.getY());
	recW=(int)(r.getWidth());
	recH=(int)(r.getHeight());
	p1=new Point(recX,recY);
        p2=new Point(recX+recW,recY);
        p3=new Point(recX,recY+recH);
        p4=new Point(recX+recW,recY+recH);
	recadre();
    }

    public void draw(Graphics g)
    {
       	Graphics2D g2=(Graphics2D) g ;
	/*	int ax=(int)r.getX(),
	    ay=(int)r.getY(),
	    aw=(int)r.getWidth(),
	    ah=(int)r.getHeight();*/
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.gray);
	//g2.drawRect(ax,ay,aw,ah);
	g2.drawRect(deprecated_x,deprecated_y,recW,recH);
	if (noeud instanceof Node){
	    simple = new BasicStroke(1,
				     BasicStroke.CAP_BUTT,
				     BasicStroke.JOIN_BEVEL,
				     0,   // Miter limit
				     new float[] {2,2},
				     0);
	    g2.setStroke(simple);
	    g2.drawLine(carreX,carreY,rondX,rondY);
	}
	g2.setStroke(new BasicStroke()); 
    }

    public Point getCenter(){
	return (new Point((int) (deprecated_x+recW/2), (int) (deprecated_y+recH/2)));
    }

    public Rectangle getBounds(){
	//return (new Rectangle(r));
	if (!recadred)
	    return (new Rectangle(r));
	
	recadred=false;
	// we are sure that the node exist !=null
	if (noeud instanceof ANode)
	    return ((ANode) noeud).getBoundsExtended();
	return noeud.getBounds();
    }


    public void updatingSelection(){
	recadre();
    }

    public void updatingSelection(MiniBox mb){
	Point2D pt1=b1.pos2Point2D();
	Point2D pt2=b2.pos2Point2D();
	Point2D pt3=b3.pos2Point2D();
	Point2D pt4=b4.pos2Point2D();
	Point2D pt5=b5.pos2Point2D();
	// I don t like this kind of comparaison
	// but it seems to work
	
	if(pt1.getX()>pt4.getX() ||
	   pt1.getY()>pt4.getY()) return;
	if(pt3.getX()>pt2.getX() ||
	   pt2.getY()>pt3.getY()) return;

	if (mb==b5) {
	    if ((pt5.getX()<carreX) ||
		(pt5.getX()>rondX)) return;
	    if (noeud instanceof Node){
		double inmr=((rondX-carreX)==0)?0:(pt5.getX()-carreX)/(rondX-carreX);
		b5.setFakePos((int)(carreX+(rondX-carreX)*inmr),
			      (int)(carreY));
		//b5.setFakePos((int)(carreX),
		//      (int)(carreY+(rondY-carreY)*inmr));
		((Node) noeud).setNmrPercent(inmr);
	    }
	} else if (mb==b1 || mb==b4) recadre(pt1,pt4); 
	else  recadre(pt2,pt3);	
    }


    public void recadre(Point2D punct1,Point2D punct2){
	// calculate the new Height and new Width
	recadred=true;
	double newH=Math.abs(punct1.getY()-punct2.getY());
	double newW=Math.abs(punct1.getX()-punct2.getX());
	double newX;
	double newY;

	newX=(punct1.getX()<punct2.getX())?punct1.getX():punct2.getX();
	newY=(punct1.getY()<punct2.getY())?punct1.getY():punct2.getY();
	
	r.setRect((double) newX,(double) newY,(double) newW,(double) newH);
	
	recX=(int) newX;
	recY=(int) newY;
	recW=(int) newW;
	recH=(int) newH;
	deprecated_x=recX;
	deprecated_y=recY;

	recadre();

	// interactive node
	double nposx=newX+newW/2;
	double nposy=newY+newH/2;
	double unit=noeud.getGgp().ratio*Configuration.scale;
	// recalculating old nMr
	double oldnmr=noeud.getpNmr();
	double oldw=noeud.getpNw()/2;
	double oldh=noeud.getpNh()/2;
	double valmin=(oldw<oldh)?oldw:oldh;
	

	double w2=(newW)/unit;//(newW-20)/unit;
	double h2=(newH)/unit;//(newH-20)/unit;
	noeud.setPos((int)(nposx+0.5),(int)(nposy+0.5));
	noeud.deprecated_setULX(noeud.getGgp().internal2UnitLength(nposx+0.5));
	noeud.deprecated_setULY(-noeud.getGgp().internal2UnitLength(nposy+0.5));
	noeud.setpNw(w2);
	noeud.setpNh(h2);
	double nvalmin=(w2<h2)?w2:h2;
	if (valmin!=0) 
	    noeud.setpNmr((oldnmr*nvalmin/2)/valmin);
	else noeud.setpNmr(0);
	return;
    }

    public void setSelectBoxNode(ANode n){
	noeud=(Node)n;
    }
}
