package jastex.old.obj;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;

import jastex.*;



public class SelectJasRectangle extends Selection {

    public MiniBox b1;

    public MiniBox b2;

    public MiniBox b3;

    public MiniBox b4;
    public MiniBox actual;
    public JasRectangle rCurve;


    public SelectJasRectangle(){}

    public SelectJasRectangle(JasRectangle rc){
	rCurve=rc;
	miniB=new Vector();
	int ulcx=(int)(rc.deprecated_getX()-rc.getInternalWidth()/2);
	int ulcy=(int)(rc.deprecated_getY()-rc.getInternalHeight()/2);
	b1=new MiniBox(ulcx,ulcy);
	b2=new MiniBox((int)(ulcx+rc.getInternalWidth()),
		       (int)(ulcy+rc.getInternalHeight()));
	b3=new MiniBox((int)(ulcx+rc.getInternalWidth()),
		       (int)(ulcy));
	b4=new MiniBox((int)(ulcx),
		       (int)(ulcy+rc.getInternalHeight()));
	miniB.addElement(b1);
	miniB.addElement(b2);
	miniB.addElement(b3);
	miniB.addElement(b4);

	b1.setSensitive(true);
	b1.cursor=new Cursor(Cursor.NW_RESIZE_CURSOR);
	b1.setDepends(this);

	b2.setSensitive(true);	
	b2.cursor=new Cursor(Cursor.SE_RESIZE_CURSOR);
	b2.setDepends(this);

	b3.setSensitive(true);	
	b3.cursor=new Cursor(Cursor.NE_RESIZE_CURSOR);
	b3.setDepends(this);

	b4.setSensitive(true);	
	b4.cursor=new Cursor(Cursor.SW_RESIZE_CURSOR);
	b4.setDepends(this);

	
	b1.setInvisibleMode(true);
	b2.setInvisibleMode(true);
	b3.setInvisibleMode(true);
	b4.setInvisibleMode(true);
    }

    public double getMinDistance(int gx,int gy){ return 1000.0; }

    public void setOffset(int posx,int posy) {}
    public void setPos(int posx,int posy) {}
    public void draw(Graphics g){
	/*
	Graphics2D g2=(Graphics2D) g ;
	BasicStroke simple = new BasicStroke(1,
					     BasicStroke.CAP_BUTT,
					     BasicStroke.JOIN_BEVEL,
					     0,   // Miter limit
					     new float[] {4,4},
					     0);
	g2.setStroke(simple);
	g2.setColor(Color.blue);

	Point2D e1=b1.pos2Point2DFake();
	Point2D e2=b2.pos2Point2DFake();

	Line2D.Double one2two=new Line2D.Double(e1,e2);

	g2.draw(one2two);
	g2.setStroke(new BasicStroke()); 
	*/
    }

    public Rectangle getBounds(){
	Rectangle r=new Rectangle(rCurve.getBounds());
	r.add(b1.pos2Point2D());
	r.add(b2.pos2Point2D());
	r.add(b3.pos2Point2D());
	r.add(b4.pos2Point2D());
	r.grow(5,5);
	return r;
    }

    public void updatingSelection(){
	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();
	Point2D e3=b3.pos2Point2D();
	Point2D e4=b4.pos2Point2D();

	if(e1.getX()>e2.getX() ||
	   e1.getY()>e2.getY()) return;
	if(e4.getX()>e3.getX() ||
	   e3.getY()>e4.getY()) return;


	double neww=e2.getX()-e1.getX();
	double newh=e2.getY()-e1.getY();
	double centerX=(e2.getX()+e1.getX())/2+0.5;
	double centerY=(e2.getY()+e1.getY())/2+0.5;
	
	rCurve.setPos((int)centerX,(int)centerY);
	rCurve.deprecated_setULX(rCurve.getGgp().internal2UnitLength(centerX));
	rCurve.deprecated_setULY(-rCurve.getGgp().internal2UnitLength(centerY));

	rCurve.setInternalWidth(neww);
	rCurve.setInternalHeight(newh);
	//rCurve.setDiameterInternal(e1.distance(e2)*2);


	int ulcx=(int)(rCurve.deprecated_getX()-rCurve.getInternalWidth()/2);
	int ulcy=(int)(rCurve.deprecated_getY()-rCurve.getInternalHeight()/2);
	b1.setFakePos(ulcx,ulcy);
	b2.setFakePos((int)(ulcx+rCurve.getInternalWidth()),
		      (int)(ulcy+rCurve.getInternalHeight()));

	b3.setFakePos((int)(ulcx+rCurve.getInternalWidth()),
		      (int)(ulcy));
	b4.setFakePos((int)(ulcx),
		      (int)(ulcy+rCurve.getInternalHeight()));


    } 

    public void updatingSelection(MiniBox mb){
	Point2D e1=b1.pos2Point2D();
	Point2D e2=b2.pos2Point2D();
	Point2D e3=b3.pos2Point2D();
	Point2D e4=b4.pos2Point2D();

	if(e1.getX()>e2.getX() ||
	   e1.getY()>e2.getY()) return;
	if(e4.getX()>e3.getX() ||
	   e3.getY()>e4.getY()) return;

	actual=mb;
	if(actual==b3){
	    b1.setPos((int)e1.getX(),(int)e3.getY());
	    b2.setPos((int)e3.getX(),(int)e2.getY());
	}
	else if (actual==b4){
	    b1.setPos((int)e4.getX(),(int)e1.getY());
	    b2.setPos((int)e2.getX(),(int)e4.getY());
	}
	updatingSelection(); 

    }
    public void recadre(){}
    public Point returnDeplacement() {return null;}   
}

