package jastex.old.obj;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.awt.geom.*;
import jastex.old.obj.JasObject;
import jastex.old.obj.Selection;
import jastex.old.gui.JasObjectToolBox;
import jastex.ObjetManager;

class UnObjetTest extends JasObject {

    public static int boxdim =20 ;

    public int x;

    public int y;

    public UnObjetTest() {}

    
    public void draw(Graphics g) {
	// ex dessineObjet
	g.setColor(Color.white);
	g.fillRect(0+x-boxdim/2, 0+y-boxdim/2, boxdim, boxdim);
	g.setColor(Color.red);
	g.drawRect(0+x-boxdim/2, 0+y-boxdim/2, boxdim, boxdim);
	//System.out.println("bah alors"); debug
    }

    public void setPos(int posx, int posy) {
	x=posx;
	y=posy;
    }

    public double getMinDistance(int gx,int gy) {
	// ex getlongueur
	int demi=boxdim/2;
	Point uple=new Point(x-demi,y-demi);
	Point uprg=new Point(x+demi,y-demi);
	Point btle=new Point(x-demi,y+demi);
	Point btrg=new Point(x+demi,y+demi);
	Point center=new Point(x,y);


	if ( center.distance(gx,gy) < demi )
	    return 0;
	if (gx < x-demi && gy < y-demi) return uple.distance(gx,gy);
	if (gx < x-demi && gy > y+demi) return btle.distance(gx,gy);
	if (gx > x+demi && gy < y-demi) return uprg.distance(gx,gy);
	if (gx > x+demi && gy > y+demi) return btrg.distance(gx,gy);
	if (gx < x-demi) return x-gx-demi;
	if (gx > x+demi) return gx-x+demi;
	if (gy < y-demi) return y-gy+demi;
	if (gy > y+demi) return gy-y-demi;
	return 0;
    }

    public Rectangle getBounds(){
	int demi=boxdim/2;
	return (new Rectangle(x-demi,y-demi,boxdim,boxdim));
    }

    public boolean isInsideRectangle(Rectangle r){
	return getBounds().intersects(r); 
    } 
    public void updatingWhenMove(JasObjectToolBox tooBox,ObjetManager manager){}
    public Selection getObjectSelection(Rectangle slct){return null;}
}
