package jastex.parsing;
import java_cup.runtime.Symbol;


class Yylex implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

    private boolean ignore_bloc = false;
    private int bracket_level = 0;
    private int bloc_brace_level =0;
    private int brace_level=0;
    private int parent_level=0;
    private String chaine;
    private String command;
    private boolean var_isCommandSet=false;
    public static boolean _VERBOSE_ = false;
    String jas_err="";
    int markedindex=0;
    private void setCommand(String s){
	command=s;
	var_isCommandSet=true;
    }
    private boolean isCommandSet(){
	return var_isCommandSet;
    } 
    public int getline(){ return yyline; }
    void adderr(String s){ jas_err+=s+"\n"; }
    String geterr(){ return jas_err; }
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yychar;
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	Yylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	Yylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Yylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yychar = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int GASTEXP = 3;
	private final int YYINITIAL = 0;
	private final int COMMENT = 1;
	private final int BLOC = 2;
	private final int yy_state_dtrans[] = {
		0,
		95,
		104,
		106
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yychar = yychar
			+ yy_buffer_index - yy_buffer_start;
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NO_ANCHOR,
		/* 70 */ YY_NO_ANCHOR,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NO_ANCHOR,
		/* 73 */ YY_NO_ANCHOR,
		/* 74 */ YY_NO_ANCHOR,
		/* 75 */ YY_NO_ANCHOR,
		/* 76 */ YY_NO_ANCHOR,
		/* 77 */ YY_NO_ANCHOR,
		/* 78 */ YY_NO_ANCHOR,
		/* 79 */ YY_NO_ANCHOR,
		/* 80 */ YY_NO_ANCHOR,
		/* 81 */ YY_NO_ANCHOR,
		/* 82 */ YY_NO_ANCHOR,
		/* 83 */ YY_NO_ANCHOR,
		/* 84 */ YY_NO_ANCHOR,
		/* 85 */ YY_NO_ANCHOR,
		/* 86 */ YY_NO_ANCHOR,
		/* 87 */ YY_NO_ANCHOR,
		/* 88 */ YY_NO_ANCHOR,
		/* 89 */ YY_NO_ANCHOR,
		/* 90 */ YY_NO_ANCHOR,
		/* 91 */ YY_NO_ANCHOR,
		/* 92 */ YY_NO_ANCHOR,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NO_ANCHOR,
		/* 95 */ YY_NOT_ACCEPT,
		/* 96 */ YY_NO_ANCHOR,
		/* 97 */ YY_NO_ANCHOR,
		/* 98 */ YY_NO_ANCHOR,
		/* 99 */ YY_NO_ANCHOR,
		/* 100 */ YY_NO_ANCHOR,
		/* 101 */ YY_NOT_ACCEPT,
		/* 102 */ YY_NO_ANCHOR,
		/* 103 */ YY_NO_ANCHOR,
		/* 104 */ YY_NOT_ACCEPT,
		/* 105 */ YY_NO_ANCHOR,
		/* 106 */ YY_NOT_ACCEPT,
		/* 107 */ YY_NO_ANCHOR,
		/* 108 */ YY_NOT_ACCEPT,
		/* 109 */ YY_NO_ANCHOR,
		/* 110 */ YY_NOT_ACCEPT,
		/* 111 */ YY_NO_ANCHOR,
		/* 112 */ YY_NOT_ACCEPT,
		/* 113 */ YY_NO_ANCHOR,
		/* 114 */ YY_NOT_ACCEPT,
		/* 115 */ YY_NO_ANCHOR,
		/* 116 */ YY_NOT_ACCEPT,
		/* 117 */ YY_NO_ANCHOR,
		/* 118 */ YY_NOT_ACCEPT,
		/* 119 */ YY_NO_ANCHOR,
		/* 120 */ YY_NOT_ACCEPT,
		/* 121 */ YY_NO_ANCHOR,
		/* 122 */ YY_NOT_ACCEPT,
		/* 123 */ YY_NO_ANCHOR,
		/* 124 */ YY_NOT_ACCEPT,
		/* 125 */ YY_NO_ANCHOR,
		/* 126 */ YY_NOT_ACCEPT,
		/* 127 */ YY_NO_ANCHOR,
		/* 128 */ YY_NOT_ACCEPT,
		/* 129 */ YY_NO_ANCHOR,
		/* 130 */ YY_NOT_ACCEPT,
		/* 131 */ YY_NO_ANCHOR,
		/* 132 */ YY_NOT_ACCEPT,
		/* 133 */ YY_NO_ANCHOR,
		/* 134 */ YY_NOT_ACCEPT,
		/* 135 */ YY_NO_ANCHOR,
		/* 136 */ YY_NOT_ACCEPT,
		/* 137 */ YY_NO_ANCHOR,
		/* 138 */ YY_NOT_ACCEPT,
		/* 139 */ YY_NO_ANCHOR,
		/* 140 */ YY_NOT_ACCEPT,
		/* 141 */ YY_NO_ANCHOR,
		/* 142 */ YY_NO_ANCHOR,
		/* 143 */ YY_NO_ANCHOR,
		/* 144 */ YY_NO_ANCHOR,
		/* 145 */ YY_NO_ANCHOR,
		/* 146 */ YY_NO_ANCHOR,
		/* 147 */ YY_NO_ANCHOR,
		/* 148 */ YY_NO_ANCHOR,
		/* 149 */ YY_NO_ANCHOR,
		/* 150 */ YY_NO_ANCHOR,
		/* 151 */ YY_NO_ANCHOR,
		/* 152 */ YY_NO_ANCHOR,
		/* 153 */ YY_NO_ANCHOR,
		/* 154 */ YY_NO_ANCHOR,
		/* 155 */ YY_NO_ANCHOR,
		/* 156 */ YY_NO_ANCHOR,
		/* 157 */ YY_NO_ANCHOR,
		/* 158 */ YY_NO_ANCHOR,
		/* 159 */ YY_NO_ANCHOR,
		/* 160 */ YY_NO_ANCHOR,
		/* 161 */ YY_NO_ANCHOR,
		/* 162 */ YY_NO_ANCHOR,
		/* 163 */ YY_NO_ANCHOR,
		/* 164 */ YY_NO_ANCHOR,
		/* 165 */ YY_NO_ANCHOR,
		/* 166 */ YY_NO_ANCHOR,
		/* 167 */ YY_NO_ANCHOR,
		/* 168 */ YY_NO_ANCHOR,
		/* 169 */ YY_NO_ANCHOR,
		/* 170 */ YY_NO_ANCHOR,
		/* 171 */ YY_NO_ANCHOR,
		/* 172 */ YY_NO_ANCHOR,
		/* 173 */ YY_NO_ANCHOR,
		/* 174 */ YY_NO_ANCHOR,
		/* 175 */ YY_NO_ANCHOR,
		/* 176 */ YY_NO_ANCHOR,
		/* 177 */ YY_NO_ANCHOR,
		/* 178 */ YY_NO_ANCHOR,
		/* 179 */ YY_NO_ANCHOR,
		/* 180 */ YY_NO_ANCHOR,
		/* 181 */ YY_NO_ANCHOR,
		/* 182 */ YY_NO_ANCHOR,
		/* 183 */ YY_NO_ANCHOR,
		/* 184 */ YY_NO_ANCHOR,
		/* 185 */ YY_NO_ANCHOR,
		/* 186 */ YY_NO_ANCHOR,
		/* 187 */ YY_NO_ANCHOR,
		/* 188 */ YY_NO_ANCHOR,
		/* 189 */ YY_NO_ANCHOR,
		/* 190 */ YY_NO_ANCHOR,
		/* 191 */ YY_NO_ANCHOR,
		/* 192 */ YY_NO_ANCHOR,
		/* 193 */ YY_NO_ANCHOR,
		/* 194 */ YY_NO_ANCHOR,
		/* 195 */ YY_NO_ANCHOR,
		/* 196 */ YY_NO_ANCHOR,
		/* 197 */ YY_NO_ANCHOR,
		/* 198 */ YY_NO_ANCHOR,
		/* 199 */ YY_NO_ANCHOR,
		/* 200 */ YY_NO_ANCHOR,
		/* 201 */ YY_NO_ANCHOR,
		/* 202 */ YY_NO_ANCHOR,
		/* 203 */ YY_NO_ANCHOR,
		/* 204 */ YY_NO_ANCHOR,
		/* 205 */ YY_NO_ANCHOR,
		/* 206 */ YY_NO_ANCHOR,
		/* 207 */ YY_NO_ANCHOR,
		/* 208 */ YY_NO_ANCHOR,
		/* 209 */ YY_NO_ANCHOR,
		/* 210 */ YY_NO_ANCHOR,
		/* 211 */ YY_NO_ANCHOR,
		/* 212 */ YY_NO_ANCHOR,
		/* 213 */ YY_NO_ANCHOR,
		/* 214 */ YY_NO_ANCHOR,
		/* 215 */ YY_NO_ANCHOR,
		/* 216 */ YY_NO_ANCHOR,
		/* 217 */ YY_NO_ANCHOR,
		/* 218 */ YY_NO_ANCHOR,
		/* 219 */ YY_NO_ANCHOR,
		/* 220 */ YY_NO_ANCHOR,
		/* 221 */ YY_NO_ANCHOR,
		/* 222 */ YY_NO_ANCHOR,
		/* 223 */ YY_NO_ANCHOR,
		/* 224 */ YY_NO_ANCHOR,
		/* 225 */ YY_NO_ANCHOR,
		/* 226 */ YY_NO_ANCHOR,
		/* 227 */ YY_NO_ANCHOR,
		/* 228 */ YY_NO_ANCHOR,
		/* 229 */ YY_NO_ANCHOR,
		/* 230 */ YY_NO_ANCHOR,
		/* 231 */ YY_NO_ANCHOR,
		/* 232 */ YY_NO_ANCHOR,
		/* 233 */ YY_NO_ANCHOR,
		/* 234 */ YY_NO_ANCHOR,
		/* 235 */ YY_NO_ANCHOR,
		/* 236 */ YY_NO_ANCHOR,
		/* 237 */ YY_NO_ANCHOR,
		/* 238 */ YY_NO_ANCHOR,
		/* 239 */ YY_NO_ANCHOR,
		/* 240 */ YY_NO_ANCHOR,
		/* 241 */ YY_NO_ANCHOR,
		/* 242 */ YY_NO_ANCHOR,
		/* 243 */ YY_NO_ANCHOR,
		/* 244 */ YY_NO_ANCHOR,
		/* 245 */ YY_NO_ANCHOR,
		/* 246 */ YY_NO_ANCHOR,
		/* 247 */ YY_NO_ANCHOR,
		/* 248 */ YY_NO_ANCHOR,
		/* 249 */ YY_NO_ANCHOR,
		/* 250 */ YY_NO_ANCHOR,
		/* 251 */ YY_NO_ANCHOR,
		/* 252 */ YY_NO_ANCHOR,
		/* 253 */ YY_NO_ANCHOR,
		/* 254 */ YY_NO_ANCHOR,
		/* 255 */ YY_NO_ANCHOR,
		/* 256 */ YY_NO_ANCHOR,
		/* 257 */ YY_NO_ANCHOR,
		/* 258 */ YY_NO_ANCHOR,
		/* 259 */ YY_NO_ANCHOR,
		/* 260 */ YY_NO_ANCHOR,
		/* 261 */ YY_NO_ANCHOR,
		/* 262 */ YY_NO_ANCHOR,
		/* 263 */ YY_NO_ANCHOR,
		/* 264 */ YY_NO_ANCHOR,
		/* 265 */ YY_NO_ANCHOR,
		/* 266 */ YY_NO_ANCHOR,
		/* 267 */ YY_NO_ANCHOR,
		/* 268 */ YY_NO_ANCHOR,
		/* 269 */ YY_NO_ANCHOR,
		/* 270 */ YY_NO_ANCHOR,
		/* 271 */ YY_NO_ANCHOR,
		/* 272 */ YY_NO_ANCHOR,
		/* 273 */ YY_NO_ANCHOR,
		/* 274 */ YY_NO_ANCHOR,
		/* 275 */ YY_NO_ANCHOR,
		/* 276 */ YY_NO_ANCHOR,
		/* 277 */ YY_NO_ANCHOR,
		/* 278 */ YY_NO_ANCHOR,
		/* 279 */ YY_NO_ANCHOR,
		/* 280 */ YY_NO_ANCHOR,
		/* 281 */ YY_NO_ANCHOR,
		/* 282 */ YY_NO_ANCHOR,
		/* 283 */ YY_NO_ANCHOR,
		/* 284 */ YY_NO_ANCHOR,
		/* 285 */ YY_NO_ANCHOR,
		/* 286 */ YY_NO_ANCHOR,
		/* 287 */ YY_NO_ANCHOR,
		/* 288 */ YY_NO_ANCHOR,
		/* 289 */ YY_NO_ANCHOR,
		/* 290 */ YY_NO_ANCHOR,
		/* 291 */ YY_NO_ANCHOR,
		/* 292 */ YY_NO_ANCHOR,
		/* 293 */ YY_NO_ANCHOR,
		/* 294 */ YY_NO_ANCHOR,
		/* 295 */ YY_NO_ANCHOR,
		/* 296 */ YY_NO_ANCHOR,
		/* 297 */ YY_NO_ANCHOR,
		/* 298 */ YY_NO_ANCHOR,
		/* 299 */ YY_NO_ANCHOR,
		/* 300 */ YY_NO_ANCHOR,
		/* 301 */ YY_NO_ANCHOR,
		/* 302 */ YY_NO_ANCHOR,
		/* 303 */ YY_NO_ANCHOR,
		/* 304 */ YY_NO_ANCHOR,
		/* 305 */ YY_NO_ANCHOR,
		/* 306 */ YY_NO_ANCHOR,
		/* 307 */ YY_NO_ANCHOR,
		/* 308 */ YY_NO_ANCHOR,
		/* 309 */ YY_NO_ANCHOR,
		/* 310 */ YY_NO_ANCHOR,
		/* 311 */ YY_NO_ANCHOR,
		/* 312 */ YY_NO_ANCHOR,
		/* 313 */ YY_NO_ANCHOR,
		/* 314 */ YY_NO_ANCHOR,
		/* 315 */ YY_NO_ANCHOR,
		/* 316 */ YY_NO_ANCHOR,
		/* 317 */ YY_NO_ANCHOR,
		/* 318 */ YY_NO_ANCHOR,
		/* 319 */ YY_NO_ANCHOR,
		/* 320 */ YY_NO_ANCHOR,
		/* 321 */ YY_NO_ANCHOR,
		/* 322 */ YY_NO_ANCHOR,
		/* 323 */ YY_NO_ANCHOR,
		/* 324 */ YY_NO_ANCHOR,
		/* 325 */ YY_NO_ANCHOR,
		/* 326 */ YY_NO_ANCHOR,
		/* 327 */ YY_NO_ANCHOR,
		/* 328 */ YY_NO_ANCHOR,
		/* 329 */ YY_NO_ANCHOR,
		/* 330 */ YY_NO_ANCHOR,
		/* 331 */ YY_NO_ANCHOR,
		/* 332 */ YY_NO_ANCHOR,
		/* 333 */ YY_NO_ANCHOR,
		/* 334 */ YY_NO_ANCHOR,
		/* 335 */ YY_NO_ANCHOR,
		/* 336 */ YY_NO_ANCHOR,
		/* 337 */ YY_NO_ANCHOR,
		/* 338 */ YY_NO_ANCHOR,
		/* 339 */ YY_NO_ANCHOR,
		/* 340 */ YY_NO_ANCHOR,
		/* 341 */ YY_NO_ANCHOR,
		/* 342 */ YY_NO_ANCHOR,
		/* 343 */ YY_NO_ANCHOR,
		/* 344 */ YY_NO_ANCHOR,
		/* 345 */ YY_NO_ANCHOR,
		/* 346 */ YY_NO_ANCHOR,
		/* 347 */ YY_NO_ANCHOR,
		/* 348 */ YY_NO_ANCHOR,
		/* 349 */ YY_NO_ANCHOR,
		/* 350 */ YY_NO_ANCHOR,
		/* 351 */ YY_NO_ANCHOR,
		/* 352 */ YY_NO_ANCHOR,
		/* 353 */ YY_NO_ANCHOR,
		/* 354 */ YY_NO_ANCHOR,
		/* 355 */ YY_NO_ANCHOR,
		/* 356 */ YY_NO_ANCHOR,
		/* 357 */ YY_NO_ANCHOR,
		/* 358 */ YY_NO_ANCHOR,
		/* 359 */ YY_NO_ANCHOR,
		/* 360 */ YY_NO_ANCHOR,
		/* 361 */ YY_NO_ANCHOR,
		/* 362 */ YY_NO_ANCHOR,
		/* 363 */ YY_NO_ANCHOR,
		/* 364 */ YY_NO_ANCHOR,
		/* 365 */ YY_NO_ANCHOR,
		/* 366 */ YY_NO_ANCHOR,
		/* 367 */ YY_NO_ANCHOR,
		/* 368 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"8:8,7:2,6,8:2,5,8:18,7,8:4,1,8:2,48,49,8:2,47,42,44,8,43:10,8:3,52,8:3,39,4" +
"6,37,46,35,46:2,40,46:3,36,46,32,46:8,38,46:3,50,2,51,8,45,8,16,24,28,23,18" +
",12,15,33,19,34,22,11,20,9,13,27,26,21,17,14,10,29,25,31,41,30,3,8,4,8:2,0:" +
"2")[0];

	private int yy_rmap[] = unpackFromString(1,369,
"0,1:5,2,3,1,4,1,5,1:6,6,7,1,8,9,1:6,10:4,11,10:4,12,10:6,13,10:11,14,10:3,1" +
"5,10:30,1,10,1,16,3,7,17,18,19,20,19,21,22,23,24,25,19,26,27,28,29,30,31,32" +
",33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57" +
",58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82" +
",83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,10," +
"105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123" +
",124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,14" +
"2,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,1" +
"61,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179," +
"180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198" +
",199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,21" +
"7,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,2" +
"36,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254," +
"255,256,257,258,259,260,261,10,262,263,264,265,266,267,268,269,270,271,272," +
"273,274,275,276,277,278,279,280,281,282,283")[0];

	private int yy_nxt[][] = unpackFromString(284,53,
"1,2,3,4,5,6,7,96,8:45,-1:58,96,7,96,-1:50,96:3,-1:46,9:4,-1:2,9:46,-1,11:2," +
"-1:2,11:48,-1:5,97,19,97,-1:50,97:3,-1:54,346,358,346:2,186,346:28,-1,187,-" +
"1,188,346,-1:49,22,100,-1:17,346:33,-1,187,-1,188,346,-1:9,110,-1:5,346:33," +
"-1,187,-1,188,346,-1:15,346:2,245,346:30,-1,187,-1,188,346,-1:9,116,-1:5,34" +
"6:33,-1,187,-1,188,346,-1:15,346:28,63,346:4,-1,187,-1,188,346,-1:15,346:14" +
",340,346:18,-1,187,-1,188,346,-1:6,1,9:4,101,10,9:46,-1:43,22,108,-1:17,346" +
":3,200,346:3,201,346:3,115,346:4,29,346:7,30,346:2,202,346:5,-1,187,-1,188," +
"346,-1:49,100,-1:15,10,-1:55,346:4,31,346:28,-1,187,-1,188,346,-1:6,1,11:2," +
"12,13,11:48,-1:9,346:4,32,346:28,-1,187,-1,188,346,-1:6,1,14,15,16,17,18,19" +
",97,20,21,308,330,341,346:2,349,346,183,184,351,346,352,346,353,354,346:2,1" +
"85,355,346:3,99,346:2,356,346:3,357,346:2,98,22,102,346:2,23,24,25,26,27,28" +
",-1:9,346:14,33,346:18,-1,187,-1,188,346,-1:15,346:4,34,346:28,-1,187,-1,18" +
"8,346,-1:33,112,-1:34,346:4,35,346:28,-1,187,-1,188,346,-1:25,114,-1:42,346" +
":5,36,346:27,-1,187,-1,188,346,-1:34,118,-1:33,346:7,221,346:4,37,346:20,-1" +
",187,-1,188,346,-1:33,120,-1:34,346:9,38,346:23,-1,187,-1,188,346,-1:20,122" +
",-1:47,346:24,39,346:8,-1,187,-1,188,346,-1:25,124,-1:42,346:15,40,346:17,-" +
"1,187,-1,188,346,-1:16,126,-1:51,346:13,41,346:19,-1,187,-1,188,346,-1:34,1" +
"28,-1:33,346:13,42,346:19,-1,187,-1,188,346,-1:27,130,-1:40,346:13,43,346:1" +
"9,-1,187,-1,188,346,-1:20,132,-1:47,346:5,44,346:27,-1,187,-1,188,346,-1:24" +
",134,-1:43,45,346:32,-1,187,-1,188,346,-1:16,136,-1:51,346:2,46,346:30,-1,1" +
"87,-1,188,346,-1:10,92,-1:57,346:27,47,346:5,-1,187,-1,188,346,-1:27,138,-1" +
":40,346:8,48,346:24,-1,187,-1,188,346,-1:24,140,-1:43,346:29,49,346:3,-1,18" +
"7,-1,188,346,-1:10,94,-1:57,346:9,50,346:23,-1,187,-1,188,346,-1:15,346:5,5" +
"1,346:27,-1,187,-1,188,346,-1:15,346:9,52,346:23,-1,187,-1,188,346,-1:15,34" +
"6:9,53,346:23,-1,187,-1,188,346,-1:15,346:8,54,346:24,-1,187,-1,188,346,-1:" +
"15,346:5,55,346:27,-1,187,-1,188,346,-1:15,346:9,56,346:23,-1,187,-1,188,34" +
"6,-1:15,346:5,57,346:27,-1,187,-1,188,346,-1:15,346:5,58,346:27,-1,187,-1,1" +
"88,346,-1:15,346:24,59,346:8,-1,187,-1,188,346,-1:15,346:24,60,346:8,-1,187" +
",-1,188,346,-1:15,346:5,61,346:27,-1,187,-1,188,346,-1:15,346:9,62,346:23,-" +
"1,187,-1,188,346,-1:15,346:9,64,346:23,-1,187,-1,188,346,-1:15,346:5,65,346" +
":27,-1,187,-1,188,346,-1:15,346:11,66,346:21,-1,187,-1,188,346,-1:15,346:32" +
",67,-1,187,-1,188,346,-1:15,346:32,68,-1,187,-1,188,346,-1:15,346:22,69,346" +
":10,-1,187,-1,188,346,-1:15,346:18,70,346:14,-1,187,-1,188,346,-1:15,346:9," +
"71,346:23,-1,187,-1,188,346,-1:15,346:2,72,346:30,-1,187,-1,188,346,-1:15,3" +
"46:9,73,346:23,-1,187,-1,188,346,-1:15,346:5,74,346:27,-1,187,-1,188,346,-1" +
":15,346:24,75,346:8,-1,187,-1,188,346,-1:15,346:24,76,346:8,-1,187,-1,188,3" +
"46,-1:15,346:2,77,346:30,-1,187,-1,188,346,-1:15,346:9,78,346:23,-1,187,-1," +
"188,346,-1:15,346:24,79,346:8,-1,187,-1,188,346,-1:15,346:12,80,346:20,-1,1" +
"87,-1,188,346,-1:15,346:12,81,346:20,-1,187,-1,188,346,-1:15,346:9,82,346:2" +
"3,-1,187,-1,188,346,-1:15,346:9,83,346:23,-1,187,-1,188,346,-1:15,346:9,84," +
"346:23,-1,187,-1,188,346,-1:15,346:9,85,346:23,-1,187,-1,188,346,-1:15,346:" +
"9,86,346:23,-1,187,-1,188,346,-1:15,346:24,87,346:8,-1,187,-1,188,346,-1:15" +
",346:12,88,346:20,-1,187,-1,188,346,-1:15,346:9,89,346:23,-1,187,-1,188,346" +
",-1:15,346:12,90,346:20,-1,187,-1,188,346,-1:15,346:5,91,346:27,-1,187,-1,1" +
"88,346,-1:15,346:8,93,346:24,-1,187,-1,188,346,-1:15,346:22,103,346:9,105,-" +
"1,187,-1,188,346,-1:15,107,346:21,109,346:9,111,-1,187,-1,188,346,-1:15,346" +
",113,346:31,-1,187,-1,188,346,-1:15,346:14,117,346:18,-1,187,-1,188,346,-1:" +
"15,187:33,-1,187,-1,187:2,-1:15,346:9,206,346:23,-1,187,-1,188,346,-1:15,34" +
"6:4,315,346:28,-1,187,-1,188,346,-1:15,207,346:32,-1,187,-1,188,346,-1:15,3" +
"46:2,331,346:30,-1,187,-1,188,346,-1:15,346:7,209,346:25,-1,187,-1,188,346," +
"-1:15,346:8,313,346:24,-1,187,-1,188,346,-1:15,346:10,213,346:22,-1,187,-1," +
"188,346,-1:15,346:19,214,346:13,-1,187,-1,188,346,-1:15,346:8,119,346:24,-1" +
",187,-1,188,346,-1:15,346:6,216,346:26,-1,187,-1,188,346,-1:15,346:12,217,3" +
"46:20,-1,187,-1,188,346,-1:15,346:10,218,346,219,346:20,-1,187,-1,188,346,-" +
"1:15,346:14,220,346:18,-1,187,-1,188,346,-1:15,346:7,366,346:6,222,346:18,-" +
"1,187,-1,188,346,-1:15,346:5,223,346:27,-1,187,-1,188,346,-1:15,346:8,318,3" +
"46:5,334,346:3,224,346:14,-1,187,-1,188,346,-1:15,121,346,316,346:4,368,346" +
":6,344,346:12,365,346:5,-1,187,-1,188,346,-1:15,346:18,317,346:14,-1,187,-1" +
",188,346,-1:15,346:9,227,346:23,-1,187,-1,188,346,-1:15,228,346:32,-1,187,-" +
"1,188,346,-1:15,346:12,123,346:20,-1,187,-1,188,346,-1:15,346:11,231,346:21" +
",-1,187,-1,188,346,-1:15,346:12,125,346:20,-1,187,-1,188,346,-1:15,346:12,1" +
"27,346:20,-1,187,-1,188,346,-1:15,346:8,129,346:24,-1,187,-1,188,346,-1:15," +
"346,234,346:31,-1,187,-1,188,346,-1:15,346:16,235,346:16,-1,187,-1,188,346," +
"-1:15,346:10,131,346:22,-1,187,-1,188,346,-1:15,346:20,320,346:12,-1,187,-1" +
",188,346,-1:15,346:2,133,346:30,-1,187,-1,188,346,-1:15,346:7,236,346:25,-1" +
",187,-1,188,346,-1:15,346:25,237,346:7,-1,187,-1,188,346,-1:15,346:12,238,3" +
"46:20,-1,187,-1,188,346,-1:15,346:10,239,346:22,-1,187,-1,188,346,-1:15,346" +
":23,135,346:9,-1,187,-1,188,346,-1:15,346:4,137,346:28,-1,187,-1,188,346,-1" +
":15,346:3,244,346:29,-1,187,-1,188,346,-1:15,346:7,367,346:6,247,346:13,139" +
",346:4,-1,187,-1,188,346,-1:15,346:6,248,346:9,321,346:2,249,346:13,-1,187," +
"-1,188,346,-1:15,346:6,250,346:26,-1,187,-1,188,346,-1:15,346:2,141,346:30," +
"-1,187,-1,188,346,-1:15,346:6,322,346:12,361,346:13,-1,187,-1,188,346,-1:15" +
",346:9,251,346:23,-1,187,-1,188,346,-1:15,346:9,142,346:23,-1,187,-1,188,34" +
"6,-1:15,346:2,143,346:30,-1,187,-1,188,346,-1:15,346:11,253,346:21,-1,187,-" +
"1,188,346,-1:15,346:2,254,346,255,346:4,256,346:2,324,346:2,257,346,323,346" +
",258,346:13,-1,187,-1,188,346,-1:15,346:11,144,346:21,-1,187,-1,188,346,-1:" +
"15,346,259,346:31,-1,187,-1,188,346,-1:15,346:13,145,346:19,-1,187,-1,188,3" +
"46,-1:15,346:8,146,346:24,-1,187,-1,188,346,-1:15,346:14,147,346:18,-1,187," +
"-1,188,346,-1:15,346:8,148,346:24,-1,187,-1,188,346,-1:15,261,346:32,-1,187" +
",-1,188,346,-1:15,346:8,149,346:24,-1,187,-1,188,346,-1:15,346:4,263,346:28" +
",-1,187,-1,188,346,-1:15,346:7,336,346:25,-1,187,-1,188,346,-1:15,346:19,26" +
"4,346:13,-1,187,-1,188,346,-1:15,346:10,265,346:22,-1,187,-1,188,346,-1:15," +
"346:12,266,346:20,-1,187,-1,188,346,-1:15,346:4,342,346:28,-1,187,-1,188,34" +
"6,-1:15,346:5,150,346:27,-1,187,-1,188,346,-1:15,346:15,268,346:17,-1,187,-" +
"1,188,346,-1:15,346:5,151,346:27,-1,187,-1,188,346,-1:15,346:9,269,346:23,-" +
"1,187,-1,188,346,-1:15,346:4,270,346:5,271,346:22,-1,187,-1,188,346,-1:15,3" +
"46:20,272,346:12,-1,187,-1,188,346,-1:15,346:14,273,346:18,-1,187,-1,188,34" +
"6,-1:15,346:18,275,362,346:13,-1,187,-1,188,346,-1:15,346:10,277,346:4,327," +
"346:17,-1,187,-1,188,346,-1:15,346:8,152,346:24,-1,187,-1,188,346,-1:15,346" +
":2,153,346:30,-1,187,-1,188,346,-1:15,346:6,278,346:26,-1,187,-1,188,346,-1" +
":15,346:2,154,346:30,-1,187,-1,188,346,-1:15,155,346:32,-1,187,-1,188,346,-" +
"1:15,346:13,281,346:19,-1,187,-1,188,346,-1:15,346:7,156,346:25,-1,187,-1,1" +
"88,346,-1:15,346:7,157,346:25,-1,187,-1,188,346,-1:15,346:7,158,346:25,-1,1" +
"87,-1,188,346,-1:15,346:4,159,346:28,-1,187,-1,188,346,-1:15,286,346:32,-1," +
"187,-1,188,346,-1:15,346:4,160,346:28,-1,187,-1,188,346,-1:15,161,346:32,-1" +
",187,-1,188,346,-1:15,346:7,162,346:25,-1,187,-1,188,346,-1:15,346:6,163,34" +
"6:26,-1,187,-1,188,346,-1:15,346:19,164,346:13,-1,187,-1,188,346,-1:15,346:" +
"9,287,346:23,-1,187,-1,188,346,-1:15,346:9,288,346:8,289,346:14,-1,187,-1,1" +
"88,346,-1:15,346:12,290,346:20,-1,187,-1,188,346,-1:15,346:5,165,346:27,-1," +
"187,-1,188,346,-1:15,346:5,166,346:27,-1,187,-1,188,346,-1:15,346:9,167,346" +
":23,-1,187,-1,188,346,-1:15,346:7,293,346:25,-1,187,-1,188,346,-1:15,346:2," +
"168,346:30,-1,187,-1,188,346,-1:15,346:5,169,346:27,-1,187,-1,188,346,-1:15" +
",346:4,170,346:28,-1,187,-1,188,346,-1:15,346:4,171,346:28,-1,187,-1,188,34" +
"6,-1:15,346:5,294,346:27,-1,187,-1,188,346,-1:15,346:14,295,346:18,-1,187,-" +
"1,188,346,-1:15,346:14,297,346:6,298,346:11,-1,187,-1,188,346,-1:15,346:9,2" +
"99,346:23,-1,187,-1,188,346,-1:15,346:19,300,346:13,-1,187,-1,188,346,-1:15" +
",346:21,329,346:11,-1,187,-1,188,346,-1:15,346:18,301,346:14,-1,187,-1,188," +
"346,-1:15,346:6,172,346:26,-1,187,-1,188,346,-1:15,346:19,350,346:13,-1,187" +
",-1,188,346,-1:15,346:6,173,346:26,-1,187,-1,188,346,-1:15,346:6,174,346:26" +
",-1,187,-1,188,346,-1:15,346:6,175,346:26,-1,187,-1,188,346,-1:15,346:10,30" +
"2,346:22,-1,187,-1,188,346,-1:15,346:14,303,346:18,-1,187,-1,188,346,-1:15," +
"346:2,176,346:30,-1,187,-1,188,346,-1:15,346:5,177,346:27,-1,187,-1,188,346" +
",-1:15,346:9,178,346:23,-1,187,-1,188,346,-1:15,346:6,179,346:26,-1,187,-1," +
"188,346,-1:15,346:9,180,346:23,-1,187,-1,188,346,-1:15,346:8,181,346:24,-1," +
"187,-1,188,346,-1:15,346:7,307,346:25,-1,187,-1,188,346,-1:15,346:8,182,346" +
":24,-1,187,-1,188,346,-1:15,346:8,189,346:24,-1,187,-1,188,346,-1:15,346:9," +
"208,346:23,-1,187,-1,188,346,-1:15,314,346:32,-1,187,-1,188,346,-1:15,346:2" +
",225,346:30,-1,187,-1,188,346,-1:15,346:7,210,346:25,-1,187,-1,188,346,-1:1" +
"5,346:8,232,346:24,-1,187,-1,188,346,-1:15,346:6,229,346:26,-1,187,-1,188,3" +
"46,-1:15,346:18,226,346:14,-1,187,-1,188,346,-1:15,346:9,242,346:23,-1,187," +
"-1,188,346,-1:15,346:7,246,346:25,-1,187,-1,188,346,-1:15,346:10,240,346:22" +
",-1,187,-1,188,346,-1:15,346:6,252,346:26,-1,187,-1,188,346,-1:15,346:9,325" +
",346:23,-1,187,-1,188,346,-1:15,346:10,337,346:22,-1,187,-1,188,346,-1:15,3" +
"46:12,267,346:20,-1,187,-1,188,346,-1:15,346:15,276,346:17,-1,187,-1,188,34" +
"6,-1:15,346:9,274,346:23,-1,187,-1,188,346,-1:15,346:14,339,346:18,-1,187,-" +
"1,188,346,-1:15,346:6,279,346:26,-1,187,-1,188,346,-1:15,346:9,291,346:23,-" +
"1,187,-1,188,346,-1:15,346:14,296,346:18,-1,187,-1,188,346,-1:15,346:10,304" +
",346:22,-1,187,-1,188,346,-1:15,346:4,190,346:5,191,346:22,-1,187,-1,188,34" +
"6,-1:15,346:2,230,346:30,-1,187,-1,188,346,-1:15,346:7,211,346:25,-1,187,-1" +
",188,346,-1:15,346:6,233,346:26,-1,187,-1,188,346,-1:15,346:10,241,346:22,-" +
"1,187,-1,188,346,-1:15,346:6,260,346:26,-1,187,-1,188,346,-1:15,346:15,280," +
"346:17,-1,187,-1,188,346,-1:15,346:14,283,346:18,-1,187,-1,188,346,-1:15,34" +
"6:6,282,346:26,-1,187,-1,188,346,-1:15,346:9,292,346:23,-1,187,-1,188,346,-" +
"1:15,346:10,305,346:22,-1,187,-1,188,346,-1:15,346:2,309,346:4,310,346:2,19" +
"2,193,312,346:20,-1,187,-1,188,346,-1:15,346:2,284,346:30,-1,187,-1,188,346" +
",-1:15,346:7,212,346:25,-1,187,-1,188,346,-1:15,346:10,243,346:22,-1,187,-1" +
",188,346,-1:15,346:6,262,346:26,-1,187,-1,188,346,-1:15,346:2,285,346:30,-1" +
",187,-1,188,346,-1:15,346:7,215,346:25,-1,187,-1,188,346,-1:15,346:7,194,34" +
"6:25,-1,187,-1,188,346,-1:15,346:2,306,346:30,-1,187,-1,188,346,-1:15,346:2" +
",363,346:4,364,346:3,332,346:21,-1,187,-1,188,346,-1:15,346:11,343,346:2,19" +
"5,346:18,-1,187,-1,188,346,-1:15,346:4,196,346:2,197,346:4,348,346:20,-1,18" +
"7,-1,188,346,-1:15,346:9,198,346:23,-1,187,-1,188,346,-1:15,346,199,346:31," +
"-1,187,-1,188,346,-1:15,346:22,203,346:4,204,346:5,-1,187,-1,188,346,-1:15," +
"346:31,205,346,-1,187,-1,188,346,-1:15,346:2,311,346:30,-1,187,-1,188,346,-" +
"1:15,319,346:32,-1,187,-1,188,346,-1:15,326,346:32,-1,187,-1,188,346,-1:15," +
"346:4,347,346:28,-1,187,-1,188,346,-1:15,346:9,328,346:23,-1,187,-1,188,346" +
",-1:15,346:9,359,346:23,-1,187,-1,188,346,-1:15,333,346:32,-1,187,-1,188,34" +
"6,-1:15,346:9,360,346:23,-1,187,-1,188,346,-1:15,335,346:32,-1,187,-1,188,3" +
"46,-1:15,338,346:32,-1,187,-1,188,346,-1:15,345,346:32,-1,187,-1,188,346,-1" +
":6");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

    return(new Symbol(sym.EOF));
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ yybegin(COMMENT); }
					case -3:
						break;
					case 3:
						{ markedindex=yy_buffer_index; brace_level=0; bracket_level=0; parent_level=0; var_isCommandSet=false; yybegin(GASTEXP); }
					case -4:
						break;
					case 4:
						{ if(_VERBOSE_) System.out.println("lexer "+yyline+" : GPLBRACE"); return(new Symbol(sym.GPLBRACE)); }
					case -5:
						break;
					case 5:
						{ if(_VERBOSE_) System.out.println("lexer "+yyline+" : GPRBRACE"); return(new Symbol(sym.GPRBRACE)); }
					case -6:
						break;
					case 6:
						{ }
					case -7:
						break;
					case 7:
						{ }
					case -8:
						break;
					case 8:
						{ /* ignoring */ }
					case -9:
						break;
					case 9:
						{ if(_VERBOSE_) System.out.println("lexer "+yyline+" : Commentaire corps");}
					case -10:
						break;
					case 10:
						{ 
  if(_VERBOSE_) System.out.println("lexer "+yyline+" : Commentaire fin");
  yybegin(YYINITIAL);
}
					case -11:
						break;
					case 11:
						{
    chaine+=yytext();
    //System.out.println("lexer "+yyline+" : BLOC : "+chaine); 
    //return new Symbol(sym.BLOC, new String(yytext()));
}
					case -12:
						break;
					case 12:
						{ bloc_brace_level++; chaine+=yytext(); /*return(new Symbol(sym.LBRACEBIS));*/}
					case -13:
						break;
					case 13:
						{ 
    if(bloc_brace_level!=0){
	bloc_brace_level--; chaine+=yytext();
	//System.out.println("lexer "+yyline+" : RBRACEBIS");
	//return(new Symbol(sym.RBRACEBIS));
    } else {
	bloc_brace_level=0;
	ignore_bloc=false;
	yybegin(YYINITIAL); //GASTEXP
	if(_VERBOSE_)  System.out.println("lexer "+yyline+" : BLOC : "+chaine);
	return new Symbol(sym.BLOC, new String(chaine));	
    } 
}
					case -14:
						break;
					case 14:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : SEP"); if(bracket_level==0 && brace_level==0 && parent_level==0) yybegin(COMMENT);}
					case -15:
						break;
					case 15:
						{ brace_level=0; bracket_level=0; parent_level=0; var_isCommandSet=false; yybegin(GASTEXP); }
					case -16:
						break;
					case 16:
						{ 
    if(!(ignore_bloc && bracket_level==0)) {
	brace_level++;
	if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LBRACE"); return(new Symbol(sym.LBRACE)); 	
    } else { chaine=""; yybegin(BLOC); }
}
					case -17:
						break;
					case 17:
						{ 
    brace_level--;
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : RBRACE"); 
    return(new Symbol(sym.RBRACE)); 
}
					case -18:
						break;
					case 18:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : SEP"); if(bracket_level==0 && brace_level==0 && parent_level==0) yybegin(YYINITIAL);}
					case -19:
						break;
					case 19:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : N_L"); if(bracket_level==0 && brace_level==0 && parent_level==0) yybegin(YYINITIAL);}
					case -20:
						break;
					case 20:
						{ System.out.println("lexer "+yyline+" : ERROR: Illegal character: <" + yytext() + "> in line: "+yyline ); 
 adderr("Warning line "+yyline+" : Illegal character <"+ yytext()+ ">");
}
					case -21:
						break;
					case 21:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -22:
						break;
					case 22:
						{ 
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NUMBER");
    return new Symbol(sym.NUMBER, new Double(yytext())); 
}
					case -23:
						break;
					case 23:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : COMMA"); return(new Symbol(sym.COMMA)); }
					case -24:
						break;
					case 24:
						{ parent_level++; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LPAR"); return(new Symbol(sym.LPAR)); }
					case -25:
						break;
					case 25:
						{ parent_level--; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : RPAR"); return(new Symbol(sym.RPAR)); }
					case -26:
						break;
					case 26:
						{ bracket_level++; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LBRACKET"); return(new Symbol(sym.LBRACKET)); }
					case -27:
						break;
					case 27:
						{ bracket_level--; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : RBRACKET"); return(new Symbol(sym.RBRACKET)); }
					case -28:
						break;
					case 28:
						{ if(_VERBOSE_) System.out.println("lexer "+yyline+" : EGAL"); return(new Symbol(sym.EGAL)); }
					case -29:
						break;
					case 29:
						{  if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NW"); return(new Symbol(sym.NW)); }
					case -30:
						break;
					case 30:
						{  if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NH"); return(new Symbol(sym.NH)); }
					case -31:
						break;
					case 31:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : SXO"); return(new Symbol(sym.SXO)); }
					case -32:
						break;
					case 32:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : SYO"); return(new Symbol(sym.SYO)); }
					case -33:
						break;
					case 33:
						{ /*if(_VERBOSE_)  System.out.println("lexer "+yyline+" : END");*/ yybegin(YYINITIAL); }
					case -34:
						break;
					case 34:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : EXO"); return(new Symbol(sym.EXO)); }
					case -35:
						break;
					case 35:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : EYO"); return(new Symbol(sym.EYO)); }
					case -36:
						break;
					case 36:
						{ /*if(_VERBOSE_)  System.out.println("lexer "+yyline+" : PUT");*/ yybegin(YYINITIAL); }
					case -37:
						break;
					case 37:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NMR"); return(new Symbol(sym.NMR)); }
					case -38:
						break;
					case 38:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NODE"); return(new Symbol(sym.NODE));}
					case -39:
						break;
					case 39:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DASH"); return(new Symbol(sym.DASH)); }
					case -40:
						break;
					case 40:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : AHNB"); return(new Symbol(sym.AHNB)); }
					case -41:
						break;
					case 41:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : FMARK"); return(new Symbol(sym.FMARK));}
					case -42:
						break;
					case 42:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : IMARK"); return(new Symbol(sym.IMARK));}
					case -43:
						break;
					case 43:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : RMARK"); return(new Symbol(sym.RMARK));}
					case -44:
						break;
					case 44:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : RDIST"); return(new Symbol(sym.RDIST)); }
					case -45:
						break;
					case 45:
						{ /*if(_VERBOSE_)  System.out.println("lexer "+yyline+" : BEGIN");*/ yybegin(YYINITIAL); }
					case -46:
						break;
					case 46:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NFILL"); return(new Symbol(sym.NFILL)); }
					case -47:
						break;
					case 47:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : EXTNL"); return(new Symbol(sym.EXTNL)); }
					case -48:
						break;
					case 48:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : ELPOS"); return(new Symbol(sym.ELPOS)); }
					case -49:
						break;
					case 49:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LOOPCW"); return(new Symbol(sym.LOOPCW)); }
					case -50:
						break;
					case 50:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : FANGLE"); return(new Symbol(sym.FANGLE)); }
					case -51:
						break;
					case 51:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : GASSET"); return(new Symbol(sym.GASSET));}
					case -52:
						break;
					case 52:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : IANGLE"); return(new Symbol(sym.IANGLE)); }
					case -53:
						break;
					case 53:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NFRAME"); return(new Symbol(sym.NFRAME)); }
					case -54:
						break;
					case 54:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NMARKS"); return(new Symbol(sym.NMARKS)); }
					case -55:
						break;
					case 55:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NLDIST"); return(new Symbol(sym.NLDIST)); }
					case -56:
						break;
					case 56:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : ELSIDE"); return(new Symbol(sym.ELSIDE)); }
					case -57:
						break;
					case 57:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : ELDIST"); return(new Symbol(sym.ELDIST)); }
					case -58:
						break;
					case 58:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : AHDIST"); return(new Symbol(sym.AHDIST)); }
					case -59:
						break;
					case 59:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : FLENGTH"); return(new Symbol(sym.FLENGTH)); }
					case -60:
						break;
					case 60:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : ILENGTH"); return(new Symbol(sym.ILENGTH)); }
					case -61:
						break;
					case 61:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NADJUST"); return(new Symbol(sym.NADJUST)); }
					case -62:
						break;
					case 62:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NLANGLE"); return(new Symbol(sym.NLANGLE)); }
					case -63:
						break;
					case 63:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : ELDISTC"); return(new Symbol(sym.ELDISTC)); }
					case -64:
						break;
					case 64:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : AHANGLE"); return(new Symbol(sym.AHANGLE)); }
					case -65:
						break;
					case 65:
						{ }
					case -66:
						break;
					case 66:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LOOPDIAM"); return(new Symbol(sym.LOOPDIAM)); }
					case -67:
						break;
					case 67:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LINEGRAY"); return(new Symbol(sym.LINEGRAY)); }
					case -68:
						break;
					case 68:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : FILLGRAY"); return(new Symbol(sym.FILLGRAY)); }
					case -69:
						break;
					case 69:
						{/* if(_VERBOSE_)  System.out.println("lexer "+yyline+" : FRAMEBOX");*/ yybegin(YYINITIAL); }
					case -70:
						break;
					case 70:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWLOOP"); return(new Symbol(sym.DRAWLOOP));}
					case -71:
						break;
					case 71:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWLINE"); return(new Symbol(sym.DRAWLINE));}
					case -72:
						break;
					case 72:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWOVAL"); return(new Symbol(sym.DRAWOVAL));}
					case -73:
						break;
					case 73:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWEDGE"); return(new Symbol(sym.DRAWEDGE));}
					case -74:
						break;
					case 74:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWRECT"); return(new Symbol(sym.DRAWRECT));}
					case -75:
						break;
					case 75:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : AHLENGTH"); return(new Symbol(sym.AHLENGTH)); }
					case -76:
						break;
					case 76:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : AHLLENGTH"); return(new Symbol(sym.AHLLENGTH)); }
					case -77:
						break;
					case 77:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NODELABEL"); return(new Symbol(sym.NODELABEL));}
					case -78:
						break;
					case 78:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LOOPANGLE"); return(new Symbol(sym.LOOPANGLE)); }
					case -79:
						break;
					case 79:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LINEWIDTH"); return(new Symbol(sym.LINEWIDTH)); }
					case -80:
						break;
					case 80:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : LINECOLOR"); return(new Symbol(sym.LINECOLOR)); }
					case -81:
						break;
					case 81:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : FILLCOLOR"); return(new Symbol(sym.FILLCOLOR)); }
					case -82:
						break;
					case 82:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : USEPACKAGE"); return(new Symbol(sym.USEPACKAGE)); }
					case -83:
						break;
					case 83:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWBPEDGE"); return(new Symbol(sym.DRAWBPEDGE));}
					case -84:
						break;
					case 84:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWBCEDGE"); return(new Symbol(sym.DRAWBCEDGE));}
					case -85:
						break;
					case 85:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWQBEDGE"); return(new Symbol(sym.DRAWQBEDGE));}
					case -86:
						break;
					case 86:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWCIRCLE"); return(new Symbol(sym.DRAWCIRCLE));}
					case -87:
						break;
					case 87:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : CURVEDEPTH"); return(new Symbol(sym.CURVEDEPTH)); }
					case -88:
						break;
					case 88:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWQBEZIER"); return(new Symbol(sym.DRAWQBEZIER));}
					case -89:
						break;
					case 89:
						{ setCommand(yytext()); ignore_bloc=true; if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWQBPEDGE"); return(new Symbol(sym.DRAWQBPEDGE));}
					case -90:
						break;
					case 90:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DRAWCBEZIER"); return(new Symbol(sym.DRAWCBEZIER));}
					case -91:
						break;
					case 91:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NADJUSTDIST"); return(new Symbol(sym.NADJUSTDIST)); }
					case -92:
						break;
					case 92:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : ENDPIC"); return(new Symbol(sym.ENDPIC));}
					case -93:
						break;
					case 93:
						{ /*if(_VERBOSE_)  System.out.println("lexer "+yyline+" : DOCUMENTCLASS");*/ yybegin(YYINITIAL); }
					case -94:
						break;
					case 94:
						{ setCommand(yytext()); if(_VERBOSE_)  System.out.println("lexer "+yyline+" : BEGINPIC"); return(new Symbol(sym.BEGINPIC));}
					case -95:
						break;
					case 96:
						{ }
					case -96:
						break;
					case 97:
						{ if(_VERBOSE_)  System.out.println("lexer "+yyline+" : SEP"); if(bracket_level==0 && brace_level==0 && parent_level==0) yybegin(YYINITIAL);}
					case -97:
						break;
					case 98:
						{ System.out.println("lexer "+yyline+" : ERROR: Illegal character: <" + yytext() + "> in line: "+yyline ); 
 adderr("Warning line "+yyline+" : Illegal character <"+ yytext()+ ">");
}
					case -98:
						break;
					case 99:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -99:
						break;
					case 100:
						{ 
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : NUMBER");
    return new Symbol(sym.NUMBER, new Double(yytext())); 
}
					case -100:
						break;
					case 102:
						{ System.out.println("lexer "+yyline+" : ERROR: Illegal character: <" + yytext() + "> in line: "+yyline ); 
 adderr("Warning line "+yyline+" : Illegal character <"+ yytext()+ ">");
}
					case -101:
						break;
					case 103:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -102:
						break;
					case 105:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -103:
						break;
					case 107:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -104:
						break;
					case 109:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -105:
						break;
					case 111:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -106:
						break;
					case 113:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -107:
						break;
					case 115:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -108:
						break;
					case 117:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -109:
						break;
					case 119:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -110:
						break;
					case 121:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -111:
						break;
					case 123:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -112:
						break;
					case 125:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -113:
						break;
					case 127:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -114:
						break;
					case 129:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -115:
						break;
					case 131:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -116:
						break;
					case 133:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -117:
						break;
					case 135:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -118:
						break;
					case 137:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -119:
						break;
					case 139:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -120:
						break;
					case 141:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -121:
						break;
					case 142:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -122:
						break;
					case 143:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -123:
						break;
					case 144:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -124:
						break;
					case 145:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -125:
						break;
					case 146:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -126:
						break;
					case 147:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -127:
						break;
					case 148:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -128:
						break;
					case 149:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -129:
						break;
					case 150:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -130:
						break;
					case 151:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -131:
						break;
					case 152:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -132:
						break;
					case 153:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -133:
						break;
					case 154:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -134:
						break;
					case 155:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -135:
						break;
					case 156:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -136:
						break;
					case 157:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -137:
						break;
					case 158:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -138:
						break;
					case 159:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -139:
						break;
					case 160:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -140:
						break;
					case 161:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -141:
						break;
					case 162:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -142:
						break;
					case 163:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -143:
						break;
					case 164:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -144:
						break;
					case 165:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -145:
						break;
					case 166:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -146:
						break;
					case 167:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -147:
						break;
					case 168:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -148:
						break;
					case 169:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -149:
						break;
					case 170:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -150:
						break;
					case 171:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -151:
						break;
					case 172:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -152:
						break;
					case 173:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -153:
						break;
					case 174:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -154:
						break;
					case 175:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -155:
						break;
					case 176:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -156:
						break;
					case 177:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -157:
						break;
					case 178:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -158:
						break;
					case 179:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -159:
						break;
					case 180:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -160:
						break;
					case 181:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -161:
						break;
					case 182:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -162:
						break;
					case 183:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -163:
						break;
					case 184:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -164:
						break;
					case 185:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -165:
						break;
					case 186:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -166:
						break;
					case 187:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -167:
						break;
					case 188:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -168:
						break;
					case 189:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -169:
						break;
					case 190:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -170:
						break;
					case 191:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -171:
						break;
					case 192:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -172:
						break;
					case 193:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -173:
						break;
					case 194:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -174:
						break;
					case 195:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -175:
						break;
					case 196:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -176:
						break;
					case 197:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -177:
						break;
					case 198:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -178:
						break;
					case 199:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -179:
						break;
					case 200:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -180:
						break;
					case 201:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -181:
						break;
					case 202:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -182:
						break;
					case 203:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -183:
						break;
					case 204:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -184:
						break;
					case 205:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -185:
						break;
					case 206:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -186:
						break;
					case 207:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -187:
						break;
					case 208:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -188:
						break;
					case 209:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -189:
						break;
					case 210:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -190:
						break;
					case 211:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -191:
						break;
					case 212:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -192:
						break;
					case 213:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -193:
						break;
					case 214:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -194:
						break;
					case 215:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -195:
						break;
					case 216:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -196:
						break;
					case 217:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -197:
						break;
					case 218:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -198:
						break;
					case 219:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -199:
						break;
					case 220:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -200:
						break;
					case 221:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -201:
						break;
					case 222:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -202:
						break;
					case 223:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -203:
						break;
					case 224:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -204:
						break;
					case 225:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -205:
						break;
					case 226:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -206:
						break;
					case 227:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -207:
						break;
					case 228:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -208:
						break;
					case 229:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -209:
						break;
					case 230:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -210:
						break;
					case 231:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -211:
						break;
					case 232:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -212:
						break;
					case 233:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -213:
						break;
					case 234:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -214:
						break;
					case 235:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -215:
						break;
					case 236:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -216:
						break;
					case 237:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -217:
						break;
					case 238:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -218:
						break;
					case 239:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -219:
						break;
					case 240:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -220:
						break;
					case 241:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -221:
						break;
					case 242:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -222:
						break;
					case 243:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -223:
						break;
					case 244:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -224:
						break;
					case 245:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -225:
						break;
					case 246:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -226:
						break;
					case 247:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -227:
						break;
					case 248:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -228:
						break;
					case 249:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -229:
						break;
					case 250:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -230:
						break;
					case 251:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -231:
						break;
					case 252:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -232:
						break;
					case 253:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -233:
						break;
					case 254:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -234:
						break;
					case 255:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -235:
						break;
					case 256:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -236:
						break;
					case 257:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -237:
						break;
					case 258:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -238:
						break;
					case 259:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -239:
						break;
					case 260:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -240:
						break;
					case 261:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -241:
						break;
					case 262:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -242:
						break;
					case 263:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -243:
						break;
					case 264:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -244:
						break;
					case 265:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -245:
						break;
					case 266:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -246:
						break;
					case 267:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -247:
						break;
					case 268:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -248:
						break;
					case 269:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -249:
						break;
					case 270:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -250:
						break;
					case 271:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -251:
						break;
					case 272:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -252:
						break;
					case 273:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -253:
						break;
					case 274:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -254:
						break;
					case 275:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -255:
						break;
					case 276:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -256:
						break;
					case 277:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -257:
						break;
					case 278:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -258:
						break;
					case 279:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -259:
						break;
					case 280:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -260:
						break;
					case 281:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -261:
						break;
					case 282:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -262:
						break;
					case 283:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -263:
						break;
					case 284:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -264:
						break;
					case 285:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -265:
						break;
					case 286:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -266:
						break;
					case 287:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -267:
						break;
					case 288:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -268:
						break;
					case 289:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -269:
						break;
					case 290:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -270:
						break;
					case 291:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -271:
						break;
					case 292:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -272:
						break;
					case 293:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -273:
						break;
					case 294:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -274:
						break;
					case 295:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -275:
						break;
					case 296:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -276:
						break;
					case 297:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -277:
						break;
					case 298:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -278:
						break;
					case 299:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -279:
						break;
					case 300:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -280:
						break;
					case 301:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -281:
						break;
					case 302:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -282:
						break;
					case 303:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -283:
						break;
					case 304:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -284:
						break;
					case 305:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -285:
						break;
					case 306:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -286:
						break;
					case 307:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -287:
						break;
					case 308:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -288:
						break;
					case 309:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -289:
						break;
					case 310:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -290:
						break;
					case 311:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -291:
						break;
					case 312:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -292:
						break;
					case 313:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -293:
						break;
					case 314:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -294:
						break;
					case 315:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -295:
						break;
					case 316:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -296:
						break;
					case 317:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -297:
						break;
					case 318:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -298:
						break;
					case 319:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -299:
						break;
					case 320:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -300:
						break;
					case 321:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -301:
						break;
					case 322:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -302:
						break;
					case 323:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -303:
						break;
					case 324:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -304:
						break;
					case 325:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -305:
						break;
					case 326:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -306:
						break;
					case 327:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -307:
						break;
					case 328:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -308:
						break;
					case 329:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -309:
						break;
					case 330:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -310:
						break;
					case 331:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -311:
						break;
					case 332:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -312:
						break;
					case 333:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -313:
						break;
					case 334:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -314:
						break;
					case 335:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -315:
						break;
					case 336:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -316:
						break;
					case 337:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -317:
						break;
					case 338:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -318:
						break;
					case 339:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -319:
						break;
					case 340:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -320:
						break;
					case 341:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -321:
						break;
					case 342:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -322:
						break;
					case 343:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -323:
						break;
					case 344:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -324:
						break;
					case 345:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -325:
						break;
					case 346:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -326:
						break;
					case 347:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -327:
						break;
					case 348:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -328:
						break;
					case 349:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -329:
						break;
					case 350:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -330:
						break;
					case 351:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -331:
						break;
					case 352:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -332:
						break;
					case 353:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -333:
						break;
					case 354:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -334:
						break;
					case 355:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -335:
						break;
					case 356:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -336:
						break;
					case 357:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -337:
						break;
					case 358:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -338:
						break;
					case 359:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -339:
						break;
					case 360:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -340:
						break;
					case 361:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -341:
						break;
					case 362:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -342:
						break;
					case 363:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -343:
						break;
					case 364:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -344:
						break;
					case 365:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -345:
						break;
					case 366:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -346:
						break;
					case 367:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -347:
						break;
					case 368:
						{ 
    if(!isCommandSet()){ yybegin(YYINITIAL); }
    chaine=yytext();
    if(_VERBOSE_)  System.out.println("lexer "+yyline+" : WORD "+chaine);
    return new Symbol(sym.WORD, new String(yytext())); 
}
					case -348:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
